/*
 * @BABOLO (C)1999, 2000 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: mesarc.c,v 1.3 2000/05/28 23:55:21 babolo Exp $
 *     $Name:  $
 */
#include "mescommon.h"
/*
 * %y - year 2 digits
 * %Y - year 4 digits
 * %M - month 2 digits
 * %l - month 3 letters
 * % -  3 
 * %d - day of month
 * %D - day of week 3 letters
 * % -   3 
 * %h - hour
 * %m - minutes
 * %s - seconds
 * %N - message's number
 * %-<F> - previous in mailbox
 * %+<F> - next in mailbox
 * %p<F> - previous by threads
 * %n<F> - next by threads
 * %t<f> - thread
 * %S - message's subject
 * %A - address
 * %a - name
 * %V - message length with headers
 * %v - message length (body only)
 * %= - message with headers
 * %C - message headers
 * %c - message without headers
 * %E - MIME multipart with MIME headers
 * %e - MIME multipart
 * <f> - format, |format-true|format-false|, | - any character except % and \0
 * <F> - format, % or |format-true|format-false|, | - any character except % and \0
 * example format for shtml:
 * <!--#exec cmd="mesarc -f '<li><strong><a href=\"message.shtml?%N\">%S</a></strong><br>\n<a href=mailto:%A>%a</a> -- <em>%d % %h:%m</em></li>\n' /www/tmp" -->
 */
int q_flag, v_flag, w_flag, b_flag, dflag, mail_opened = 0, filebdes, filemail;
off_t mail_len;
char *mail_pos, *mail_body;
unsigned onenum[] = {0, 0};
regex_t subj1_ex;
int subj1_ex_true;

extern char *th_names[], *code_names[], *encapsulation_names[];
extern void miminit();
extern int print_escaped(char c);
extern void print_s_escaped(char p[]);
extern void nw_transfer(unsigned char c, unsigned e, int flags);
extern void multi_transfer( char *pos, unsigned len
                          , unsigned boundp, unsigned boundl
                          , struct shformat shformat
                          , char *chain
                          , int flags, unsigned *mailn
                          );
extern void  mime_transfer( unsigned char *begin, unsigned len
                          , struct shformat shformat
                          , int flags, unsigned *mailn
                          );

int print_tree( unsigned char *vector
              , unsigned boxsize
              , unsigned bemail
              , char *nformat
              , char *format
              , struct shformat shformat
              , char delimiter
              , struct tinterval tinterval
              );

void m_seek(off_t pos, size_t len)
{   switch (mail_opened)
    {case 0:
        if (db->header.flags & PATH_IS_PIPE)
        {   int i, fd[2];
            if (pipe(fd))                                                  perr(EX_IOERR, NULL);
            if ((i = fork()) < 0)                                          perr(EX_IOERR, NULL);
            if (!i)
            {   if (dup2(1, fd[1]))                                        perr(EX_IOERR, NULL);
                execl("/bin/sh", "/bin/sh", "-c", db->header.path);        perr(EX_IOERR, NULL);
            };
            filemail = fd[0];
        }else
        {   if ((filemail = open(mail_f_name, O_RDONLY)) < 0)              perr(EX_NOINPUT, db->header.path);
            if (flock(filemail, LOCK_SH))                                  perr(EX_IOERR, db->header.path);
        };
        if ((MAIL_F = fdopen(filemail, "r")) == NULL)                      perr(EX_NOINPUT, db->header.path);
        break;
     case 2:
        if (mail_body && munmap((void*)mail_body, mail_len))               perr(EX_IOERR, NULL);
    };
    mail_opened = 1;
    mail_body = NULL;
    mail_len = 0;
    if (len == 0)
    {   if (fseek(MAIL_F, pos, SEEK_SET))                                  perr(EX_IOERR, NULL);
    }else
    {   if ((void*)(mail_body = (char*)mmap( NULL     , len + (pos & P_MASK)
                                           , PROT_READ | PROT_WRITE, MAP_PRIVATE
                                           , filemail , pos & ~P_MASK
                                           )
                                ) == MAP_FAILED
                   )                                                       perr(EX_NOINPUT, NULL);
        mail_pos = mail_body + (pos & P_MASK);
        mail_len = len + (pos & P_MASK);
}   };

int m_getc()
{   switch (mail_opened)
    {case 1: return(fgetc(MAIL_F));
     case 2: if (mail_pos < mail_body + mail_len) return(*mail_pos++ & 0377);
             /* !!! no break !!! */
     default:return(EOF);
}   };

void w_s_transfer(char p[])
{   int i;

    if (p) for (i = 0; p[i]; i++) nw_transfer(p[i], no_code, w_flag ? WWW_FLAG : 0);
};

void mail_transfer(unsigned offset, unsigned length, enum code code, char *bstr)
{   int c, e = code & 0377 & ~CODEMASK;
    int newstr = 1;

    m_seek(offset, 0);
    while (length--)
    {   if ((c = m_getc()) == EOF)
        {   if (v_flag) fprintf(stderr, "EOF at offset=%u, length=%u\n", offset, length);
            break;
        };
        if (c == '\n') newstr = 1;
        else if (newstr)
        {   w_s_transfer(bstr);
            newstr = 0;
        }
        nw_transfer(c, e, (w_flag && !(code & CODEMASK)) ? WWW_FLAG : 0);
}   };

char *format_purge(char *f, char end_char)
{   char c;

    while ((c = *f++) != end_char)
        if (!c && v_flag)
        {   fprintf( stderr, "%s: Illegal format string: '\\0' while seek '%c'\n", myname, end_char);
            return(--f);
        };
    return(f);
};

void vprint_entry(int bemail, struct db_entry *entry)
{   unsigned char *p;
    fprintf( stderr
           , "N%u off = %u\n  hl=%u bl=%u prev=%u next=%u right=%d th=%s plex=%u lext=%u\n"
             "  code=%u<%s> (%s) encaps=%s"
           , db->header.N_start + bemail, entry->offset
           , entry->headerl, entry->bodyl
           , (unsigned)(entry->prev ? db->header.N_start + bemail + entry->prev : 0)
           , (unsigned)(entry->next ? db->header.N_start + bemail + entry->next : 0)
           , (int)(entry->right), th_names[entry->th]
           , entry->plex, entry->lext
           , entry->charset & 0377 & ~CODEMASK
           , code_names[entry->charset & 0377 & ~CODEMASK]
           ,   (entry->bound)
             ? "multipart"
             :   (entry->charset & CODEMASK)
               ? "text/html"
               : ((entry->charset & 0377 & ~CODEMASK) == code_unknown) ? "*/*" : "text/plain"
           , encapsulation_names[entry->encapsulation & 0377]
           );
    if (entry->bound) fprintf( stderr, " bound offset=%u len=%u\n"
                             , entry->bound
                             , (unsigned)(entry->boundl)
                             );
      else fprintf( stderr, "\n");
    if (entry->bound && v_flag > 2)
    {   unsigned l, u;
        int c;

        fprintf( stderr, "  Boundary=\"");
        u = entry->boundl;
        l = entry->offset + entry->bound;
        m_seek(l, 0);
        while (u--)
        {   if ((c = m_getc()) == EOF)
            {   if (w_flag) fprintf(stderr, "EOF at offset=%u, length=%u\n", l, u);
                break;
            };
            putc(c, stderr);
        };
        fprintf( stderr, "\"\n");
    };
    fprintf( stderr
#ifdef LL_FORMAT
           , "    subj.%016llX mail.%016llX\n    repl.%016llX id.%016llX\n"
/* Yes, I see. ll format is not I want */
#else
           , "    subj.%016qX mail.%016qX\n    repl.%016qX id.%016qX\n"
#endif
           , entry->subj_hash, entry->mail_hash
           , entry->repl_hash, entry->id_hash
           );
    fprintf(stderr, "    mail %s", ctime(&entry->mail_time));
    fprintf(stderr, "   store %s", ctime(&entry->stored_time));
    if (db->header.LList) fprintf(stderr, "  ListM=%X", (unsigned)tomask(entry->var));
    p = VAR_STR;
    fprintf(stderr, "  %s", p);
    p = index(p, '\0') + 1;
    fprintf(stderr, " (%s)", p);
    p = index(p, '\0') + 1;
    fprintf(stderr, " \"%s\"\n", p);
};

int print_entry( unsigned boxsize
               , unsigned bemail
               , struct db_entry *entry
               , char *f, struct shformat shformat
               , char end_char
               , char *chain
               )
/* return 1 if printed with no errors */
/* return 0 if not printed            */
/* return -1 if printed with errors   */
{   unsigned char *p;
    int c;
    struct tm *tm;
    unsigned l;
    char *tmp = f;

    if (v_flag > 1) vprint_entry(bemail, entry);
    tm = localtime(&entry->mail_time);
    if (!f) return(0);
    if (db->header.LList && ListM && !(ListM & tomask(entry->var))) return(0);
    while ((c = *f++))
        if (c == end_char) break;
        else if (c == '\\')
        {   if(print_escaped(c = *(f++)))
            {   if (v_flag) fprintf( stderr, "%s: Illegal format string: '\\0' after '\\\\' %s\n", myname, tmp);
                return(-1);
            };
        }else if (c == '%')
        {   if (!(c = *(f++)))
            {   putchar('%');
        ;   ;   if (v_flag) fprintf( stderr, "%s: Illegal format string: '\\0' after '%%' in %s\n", myname, tmp);
        ;   ;   return(-1);
        ;   };
        ;   if (c == end_char)
            {   putchar('%');
        ;   ;   if (v_flag) fprintf( stderr, "%s: Illegal format string: end_char '%c' after '%%' in %s\n", myname, end_char, tmp);
        ;   ;   return(-1);
        ;   };
        ;   onenum[0] = db->header.N_start + bemail;
            switch (c)
            {case '%': putchar('%');                                            break;
        ;   ;case 'y': printf("%02u", (unsigned)(tm->tm_year % 100));           break;
        ;   ;case 'Y': printf("%04u", (unsigned)(tm->tm_year + 1900));          break;
        ;   ;case 'M': printf("%02u", (unsigned)(tm->tm_mon + 1));              break;
        ;   ;case 'l': printf("%s", months[tm->tm_mon]);                        break;
        ;   ;case '': printf("%s", months[tm->tm_mon + 12]);                   break;
        ;   ;case 'd': printf("%02u", (unsigned)(tm->tm_mday));                 break;
        ;   ;case 'D': printf("%s", weekdays[tm->tm_wday]);                     break;
        ;   ;case '': printf("%s", weekrs[tm->tm_wday]);                       break;
        ;   ;case 'h': printf("%02u", (unsigned)(tm->tm_hour));                 break;
        ;   ;case 'm': printf("%02u", (unsigned)(tm->tm_min));                  break;
        ;   ;case 's': printf("%02u", (unsigned)(tm->tm_sec));                  break;
        ;   ;case 'N': printf("%u", (unsigned)(db->header.N_start + bemail));   break;
        ;   ;case 'A': printf("%s", VAR_STR);                                   break;
        ;   ;case 'V': printf("%u", entry->bodyl);                              break;
        ;   ;case 'v': printf("%u", entry->bodyl - entry->headerl);             break;
        ;   ;case 'a':
        ;   ;   p = VAR_STR;
        ;   ;   p = index(p, '\0') + 1;
        ;   ;   if ((p < ((unsigned char*)entry) + DB_BLOCK_SIZE) && (*p != '\0')) w_s_transfer(p);
                  else w_s_transfer(VAR_STR);
        ;   ;   break;
        ;   ;case 'S':
        ;   ;   p = VAR_STR;
        ;   ;   p = index(p, '\0') + 1;
        ;   ;   if (p < ((unsigned char*)entry) + DB_BLOCK_SIZE)
                {   p = index(p, '\0') + 1;
        ;   ;       if ((p < ((unsigned char*)entry) + DB_BLOCK_SIZE) && (*p != '\0')) w_s_transfer(p);
                      else printf("(no subj)");
        ;   ;   }else printf("(no subj)");
        ;   ;   break;
        ;   ;case 'R':
        ;   ;   p = VAR_STR;
        ;   ;   p = index(p, '\0') + 1;
        ;   ;   if (p < ((unsigned char*)entry) + DB_BLOCK_SIZE)
                {   p = index(p, '\0') + 1;
        ;   ;       if ((p < ((unsigned char*)entry) + DB_BLOCK_SIZE) && (*p != '\0'))
                    {   regmatch_t pmatch[3];
        ;   ;           if (!subj1_ex_true) exr(&subj1_ex, RE_EXCL_RE, REG_EXTENDED | REG_ICASE);
        ;   ;           subj1_ex_true = 1;
        ;   ;           w_s_transfer(regexec(&subj1_ex, p, 3, pmatch, 0) ? p : &p[pmatch[0].rm_eo]);
        ;   ;   }   }
        ;   ;   break;
        ;   ;case 'E':
        ;   ;   if (entry->boundl)
                {   m_seek(entry->offset, entry->bodyl);
        ;   ;       multi_transfer( mail_pos, entry->bodyl
                                  , entry->bound, entry->boundl
                                  , shformat
                                  , chain
                                  , HDR_FLAG | ((w_flag) ? WWW_FLAG : 0) | ((b_flag) ? BIN_FLAG : 0)
                                  , onenum
                                  );
        ;   ;       break;
        ;   ;   };
        ;   ;   if ((entry->charset & 0377 & ~CODEMASK) == code_unknown)
                {   m_seek(entry->offset, entry->bodyl);
                    mime_transfer( mail_pos, entry->bodyl
                                  , shformat
                                  , HDR_FLAG | ((w_flag) ? WWW_FLAG : 0) | ((b_flag) ? BIN_FLAG : 0)
                                  , onenum
                                  );
        ;   ;       break;
        ;   ;   };
        ;   ;case '=':
        ;   ;   print_s_escaped(shformat.B_str);
        ;   ;   mail_transfer(entry->offset, entry->bodyl, no_code, NULL);
        ;   ;   print_s_escaped(shformat.E_str);
        ;   ;   break;
        ;   ;case 'C':
        ;   ;   print_s_escaped(shformat.B_str);
        ;   ;   mail_transfer(entry->offset, entry->headerl, entry->charset, NULL);
        ;   ;   print_s_escaped(shformat.E_str);
        ;   ;   break;
        ;   ;case 'e':
        ;   ;   if (entry->boundl)
                {   m_seek(entry->offset, entry->bodyl);
        ;   ;       multi_transfer( mail_pos, entry->bodyl
                                  , entry->bound, entry->boundl
                                  , shformat
                                  , chain
                                  , ((w_flag) ? WWW_FLAG : 0) | ((b_flag) ? BIN_FLAG : 0)
                                  , onenum
                                  );
        ;   ;       break;
        ;   ;   };
        ;   ;   if ((entry->charset & 0377 & ~CODEMASK) == code_unknown)
                {   m_seek(entry->offset, entry->bodyl);
                    mime_transfer( mail_pos, entry->bodyl
                                  , shformat
                                  , ((w_flag) ? WWW_FLAG : 0) | ((b_flag) ? BIN_FLAG : 0)
                                  , onenum
                                  );
        ;   ;       break;
        ;   ;   };
        ;   ;case 'c':
        ;   ;   print_s_escaped(shformat.B_str);
        ;   ;   mail_transfer( entry->offset + entry->headerl
                             , entry->bodyl - entry->headerl
                             , entry->charset
                             , NULL
                             );
        ;   ;   print_s_escaped(shformat.E_str);
        ;   ;   break;
        ;   ;case 'r':
        ;   ;   mail_transfer( entry->offset + entry->headerl
                             , entry->bodyl - entry->headerl
                             , entry->charset
                             , RE_STRING
                             );
        ;   ;   break;
        ;   ;case '-':
        ;   ;   if (!(c = *(f++)))
                {   printf("%%-");
        ;   ;       if (v_flag) fprintf( stderr, "%s: Illegal format string: '\\0' after '%%-' in %s\n", myname, tmp);
        ;   ;       return(-1);
        ;   ;   };
        ;   ;   if (0 < bemail - 1 && bemail - 1 <= arcsize)
                    if (c == '%') printf("%u", db->header.N_start + bemail - 1);
                    else
                    {   print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;           f = format_purge(f, c);
        ;   ;           f = format_purge(f, c);
        ;   ;       }
                else if (c != '%')
                {   f = format_purge(f, c);
        ;   ;       print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;       f = format_purge(f, c);
        ;   ;   };  break;
        ;   ;case '+':
        ;       if (!(c = *(f++)))
                {   printf("%%+");
        ;   ;       if (v_flag) fprintf( stderr, "%s: Illegal format string: '\\0' after '%%+' in %s\n", myname, tmp);
        ;   ;       return(-1);
        ;   ;   };
        ;   ;   if (0 < bemail + 1 && bemail + 1 <= arcsize)
                    if (c == '%') printf("%u", db->header.N_start + bemail + 1);
                    else
                    {   print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;           f = format_purge(f, c);
        ;   ;           f = format_purge(f, c);
        ;   ;       }
                else if (c != '%')
                {   f = format_purge(f, c);
        ;   ;       print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;       f = format_purge(f, c);
        ;   ;   };  break;
        ;   ;case 'p':
        ;   ;   if (!(c = *(f++)))
                {   printf("%%+");
        ;   ;       if (v_flag) fprintf( stderr, "%s: Illegal format string: '\\0' after '%%p' in %s\n", myname, tmp);
        ;   ;       return(-1);
        ;   ;   };
        ;   ;   if (entry->prev)
                    if (c == '%') printf("%u", (unsigned)(db->header.N_start + bemail + entry->prev));
                    else
                    {   print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;           f = format_purge(f, c);
        ;   ;           f = format_purge(f, c);
        ;   ;       }
                else if (c != '%')
                {   f = format_purge(f, c);
        ;   ;       print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;       f = format_purge(f, c);
        ;   ;   };  break;
        ;   ;case 'n':
        ;   ;   if (!(c = *(f++)))
                {   printf("%%+");
        ;   ;       if (v_flag) fprintf( stderr, "%s: Illegal format string: '\\0' after '%%n' in %s\n", myname, tmp);
        ;   ;       return(-1);
        ;   ;   };
        ;   ;   if (entry->next)
                    if (c == '%') printf("%u", (unsigned)(db->header.N_start + bemail + entry->next));
                    else
                    {   print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;           f = format_purge(f, c);
        ;   ;           f = format_purge(f, c);
        ;   ;       }
                else if (c != '%')
                {   f = format_purge(f, c);
        ;   ;       print_entry(boxsize, bemail, entry, f, shformat, c, NULL);
        ;   ;       f = format_purge(f, c);
        ;   ;   };  break;
        ;   ;case 't':
        ;   ;   if (!(c = *(f++)))
                {   printf("%%t");
        ;   ;       if (v_flag) fprintf( stderr, "%s: Illegal format string: '\\0' after '%%t' in %s\n", myname, tmp);
        ;   ;       return(-1);
        ;   ;   };
        ;   ;   l = bemail;
        ;   ;   if (c != '%')
                {   char *f1 = format_purge(f, c);
                    (void)print_tree( NULL, boxsize, bemail, f, f1, shformat, c
                                    , (struct tinterval){0,2147483647}
                                    );
        ;   ;       f = format_purge(f1, c);
                };
                break;
        ;   ;default : putchar('%'); putchar(c);
        ;   }
        }else putchar(c);
    return(1);
};

int print_tree( unsigned char *vector
              , unsigned boxsize
              , unsigned bemail
              , char *nformat, char *format
              , struct shformat shformat
              , char delimiter
              , struct tinterval tinterval
              )
/* return 1 if printed with no errors */
/* return 0 if not printed            */
/* return -1 if printed with errors   */
{   int from_level, level, r = 0;
    unsigned i, j;

    from_level = 0;
    level = 0;
    i = bemail;
    j = 0;
    while (i && ENTRY(i)->prev && ENTRY(i)->th != th_root)
    {   i += ENTRY(i)->prev;
        if (j++ > boxsize)
        {   fprintf(stderr, "%s: mail prev cicle from %u\n", myname, bemail);
            break;
    }   };
    while (i)
    {   if (v_flag > 2) fprintf(stderr, "print_entry %u?\n", i);
        if (level < 0) level = 0;
        if (  (!db->header.LList || !ListM || ListM & tomask(ENTRY(i)->var))
           && (tinterval.nomin || ENTRY(i)->stored_time >= tinterval.tmin)
           && (tinterval.nomax || ENTRY(i)->stored_time <= tinterval.tmax)
           && (!vector || !vector[i - 1])
           )
        {   while (from_level < level)
            {   print_s_escaped(shformat.R_str);
                from_level++;
            };
            while (from_level > level)
            {   print_s_escaped(shformat.L_str);
                from_level--;
            };
            r |= print_entry( boxsize, i, ENTRY(i)
                            , (i == bemail) ? nformat : format
                            , shformat
                            , delimiter
                            , NULL
                            );
        };
        if (vector) vector[i - 1] = 1;
        if (!ENTRY(i)->next) break;
        i += ENTRY(i)->next;
        if (ENTRY(i)->th == th_root) break;
        level += ENTRY(i)->right;
        if (ENTRY(i)->th == th_cousen) level = 0;
    };
    while (from_level > 0)
    {   print_s_escaped(shformat.L_str);
        from_level--;
    };
    return(r);
};

char *f2s_copy(char *file)
{   struct stat sb;
    int f;
    char *p, *t;
    size_t r, rr;

    if  ((f = open(file, O_RDONLY)) < 0)                                    perr(EX_NOINPUT, NULL);
    if  (fstat(f, &sb))                                                     perr(EX_NOINPUT, NULL);
    if  ((p = malloc(sb.st_size + 1)) == NULL)                              perr(EX_UNAVAILABLE, NULL);
    for (t = p, r = sb.st_size; r > 0; t += rr, r -= rr)
    {   rr = read(f, t, r);
        if  (rr < 0 && errno != EINTR && errno != EAGAIN)                   perr(EX_NOINPUT, NULL);
    }
    *t = '\0';
    close(f);
    return(p);
}

void usage(int exitcode)
{   fprintf( stderr
           , "messarge "VERS" @BABOLO http://www.links.ru/soft/messarge/\n"
             "%s -<options> <file IDX> [<message numbers>]\n"
             "  -v - verbose (debug)\n"
             "  -w - ready for WWW\n"
             "  -u - do not update index\n"
             "  -t - thread sorted when print index\n"
             "  -tt - print only one entry on every thread\n"
             "  -i - message numbers parameters do NOT proceed. Imply -c\n"
             "  -c - message numbers parameters sorted, then proceeded\n"
             "  -b - binary data not rejected\n"
             "  -s <secs> - display messages indexed last <secs> sec\n"
             "  -f - entry print format\n"
             "      %%y - year 2 digits\n"
             "      %%Y - year 4 digits\n"
             "      %%M - month 2 digits\n"
             "      %%l - month 3 letters\n"
             "      %% -  3 \n"
             "      %%d - day of month\n"
             "      %%D - day of week 3 letters\n"
             "      %% -   3 \n"
             "      %%h - hour\n"
             "      %%m - minutes\n"
             "      %%s - seconds\n"
             "      %%N - message's number\n"
             "      %%-<F> - previous in mailbox\n"
             "      %%+<F> - next in mailbox\n"
             "      %%p<F> - previous by threads\n"
             "      %%n<F> - next by threads\n"
             "      %%t<t> - thread\n"
             "      %%S - message's subject\n"
             "      %%A - address\n"
             "      %%a - name\n"
             "      %%V - message length with headers\n"
             "      %%v - message length (body only)\n"
             "      %%C - message headers\n"
             "      %%c - message without headers\n"
             "      %%= - whole message as is\n"
             "      %%E - message decoded with MIME headers\n"
             "      %%c - message decoded without MIME headers\n"

             "        <f> - format, |format-true|format-false|, | - any character except '%%' and '\\0'\n"
             "        <F> - format, %% or |format-true|format-false|, | - any character except '%%' and '\\0'\n"
             "  -F - file with format\n"
             "  -L - string to shift left\n"
             "  -R - string to shift right\n"
             "  -T - string to delimit threads or attaches\n"
             "  -B - string to begin text/plain with\n"
             "  -E - string to end text/plain with\n"
             "  -l<list number>\n"
             " example of use in .shtml file to list all messages\n"
             " <!--#exec cmd=\"mesarc -twf '<li><strong><a href=\\\"message.shtml?%%N\\\">%%S</a></strong><br>\n<a href=mailto:%%A>%%a</a> -- <em>%%d %% %%h:%%m</em></li>\n' /www/tmp\" -->\n"
           , myname);
     exit(exitcode);
};

int main(int argc, char **argv)
{   int c, i;
    int t_flag, i_flag, c_flag, u_flag;
    char *format;
    struct shformat shformat;
    MASK_T u;
    unsigned char *vector;
    unsigned char *empty = "";
    struct tinterval tinterval;
#ifdef DEBUG
# if DEBUG > 1
    char argv0[] = "mesarc";
    char argv1[] = "-cf%e";
    char argv2[] = "zm.db";
    char argv3[] = "1154";
    char *arg[] = {argv0, argv1, argv2, argv3, NULL};
    argv = arg;
    argc = 4;
# endif
#endif

    myname = argv[0];
    v_flag = w_flag = t_flag = i_flag = c_flag = u_flag = dflag = 0;
    mail_opened = 0;
    subj1_ex_true = 0;
    opterr = 0;
    format = empty;
    shformat.L_str = shformat.R_str = shformat.T_str = shformat.B_str = shformat.E_str = empty;
    shformat.A_str = empty;
    tinterval.nomin = tinterval.nomax = 1;
    while((c = getopt(argc, argv, "vwticbs:S:f:F:L:R:T:B:E:A:l:?")) !=  -1)
    {   switch(c)
        {case 'v': v_flag++;                 break;
         case 'w': w_flag++;
            if (shformat.L_str == empty) shformat.L_str = "</ul>\n";
            if (shformat.R_str == empty) shformat.R_str = "<ul>\n";
            if (shformat.T_str == empty) shformat.T_str = "<hr>\n";
            if (shformat.B_str == empty) shformat.B_str = "<code><pre>";
            if (shformat.E_str == empty) shformat.E_str = "</pre></code>";
            if (shformat.A_str == empty) shformat.A_str = "<a href=mesbin.cgi?%P>%F</a>\n";
            break;
         case 'u': u_flag++;                 break;
         case 't': t_flag++;                 break;
         case 'i': i_flag++;                 break;
         case 'c': c_flag++;                 break;
         case 'b': b_flag++;                 break;
         case 's':
            if (tinterval.nomin)
            {   tinterval.tmin = (time_t)STRTOQ(optarg, NULL, 0);
                if (time(NULL) > tinterval.tmin) tinterval.tmin = time(NULL) - tinterval.tmin;
                  else tinterval.tmin = 0;
                tinterval.nomin = 0;
            }else if (tinterval.nomax)
            {   tinterval.tmax = (time_t)STRTOQ(optarg, NULL, 0);
                if (time(NULL) > tinterval.tmax)
                {   if (tinterval.tmin > tinterval.tmax) tinterval.tmin -= tinterval.tmax;
                      else tinterval.tmin = 0;
                    tinterval.tmax = time(NULL) - tinterval.tmax;
                    tinterval.nomax = 0;
            }   };
            break;
         case 'S':
            if (tinterval.nomin)
            {   tinterval.tmin = (time_t)STRTOQ(optarg, NULL, 0);
                tinterval.nomin = 0;
            }else if (tinterval.nomax)
            {   tinterval.tmax = (time_t)STRTOQ(optarg, NULL, 0);
                tinterval.nomax = 0;
            };
            break;
         case 'f': format = optarg;          break;
         case 'F': format = f2s_copy(optarg);break;
         case 'L': shformat.L_str = optarg;  break;
         case 'R': shformat.R_str = optarg;  break;
         case 'T': shformat.T_str = optarg;  break;
         case 'B': shformat.B_str = optarg;  break;
         case 'E': shformat.E_str = optarg;  break;
         case 'A': shformat.A_str = optarg;  break;
         case 'l':
            i = (int)strtol(optarg, NULL, 0);
            if (i > MAX_L_NUMBER) usage(EX_USAGE);
            if (i < 1) usage(EX_USAGE);
            for (u = 1; i > 1; i--) u *= 2;
            ListM |= u;
            break;
         default: usage(EX_USAGE);
    }   };
    argc -= optind;
    argv += optind;
    c_flag |= i_flag;

    if (argc < 1) usage(EX_USAGE);
    db = calloc(1, sizeof(struct db));
    arcsize = open_db(argv[0], u_flag ? read_m : readup_m);
    if (db->header.path[0] != '/')
    {   char *c;
        (void)strncpy(mail_f_name, argv[0], WORK_SIZE - 1);
        c = rindex(mail_f_name, '/');
        if (c)
        {   *(++c) = '\0';
            (void)strncat(mail_f_name, db->header.path, WORK_SIZE - strlen(mail_f_name) - 1);
        }else (void)strncpy(mail_f_name, db->header.path, WORK_SIZE - 1);
    }else (void)strncpy(mail_f_name, db->header.path, WORK_SIZE - 1);

    argc--;
    argv++;
    miminit();
    if (v_flag) fprintf( stderr, "messarge "VERS" http://www.links.ru/soft/messarge/\n");
    if (v_flag) fprintf( stderr, "blocksize = %u, dbsize = %u,"
                       , (unsigned)(DB_BLOCK_SIZE), (unsigned)arcsize);
    arcsize = (arcsize / DB_BLOCK_SIZE) - db->header.len;
    if (v_flag) fprintf( stderr
                       , " %u listed\nheader=%u blocks, N_start=%u, NLists=%u, LList=%u\n"
                         "mailbox=%s~\nformat=%s~\n"
                       , (unsigned)arcsize
                       , db->header.len
                       , db->header.N_start
                       , (unsigned)db->header.NLists
                       , (unsigned)db->header.LList
                       , db->header.path
                       , format
                       );
    if ((void*)(entries = (struct db_entry*)mmap( NULL
                                                , (arcsize + db->header.len) * DB_BLOCK_SIZE
                                                , PROT_READ, MAP_PRIVATE, filebdes, 0
                                                )
               ) == MAP_FAILED
       )                                                                   perr(EX_NOINPUT, argv[0]);
    vector = (unsigned char*)calloc(1, arcsize);
    if (argc)
    {   int i;
        char *chain;

        if (!i_flag) memset(vector, 1, arcsize);
        while (argc--)
        {   i = (int)strtol(*argv++, &chain, 0) - db->header.N_start;
            if (1 > i || i > arcsize)
            {   fprintf( stderr, "Mail number %u not in %u .. %u\n"
                       , db->header.N_start + bemail
                       , db->header.N_start + 1
                       , (unsigned)(db->header.N_start + arcsize)
                       );
                exit(EX_USAGE);
             };
             if (c_flag) vector[i - 1] = i_flag ? 1 : 0;
             else (void)print_entry((unsigned)arcsize, i, ENTRY(i), format, shformat, '\0', chain);
        };
    }else c_flag = 1;
    if (c_flag && t_flag == 1)
    {   for (bemail = 1; bemail <= arcsize; bemail++)
        {   if (v_flag > 2) fprintf(stderr, "print_tree %u?\n", bemail);
            if (!vector[bemail - 1])
                if (print_tree(vector, (unsigned)arcsize, bemail
                              , format, format, shformat, '\0', tinterval)
                              )
                    print_s_escaped(shformat.T_str);
        };
    }else if (c_flag) /* t_flag == 0 or t_flag == 2 but not t_flag == 1 */
    {   for (bemail = 1; bemail <= arcsize; bemail++)
            if (!vector[bemail - 1])
            {   if (v_flag > 2) fprintf(stderr, "print %u?\n", bemail);
                if (  (tinterval.nomin || ENTRY(bemail)->stored_time >= tinterval.tmin)
                   && (tinterval.nomax || ENTRY(bemail)->stored_time <= tinterval.tmax)
                   )(void)print_entry((unsigned)arcsize, bemail, ENTRY(bemail), format, shformat, '\0', NULL);
                i = bemail;                                          /**/
                do                                                   /********************/
                {   if (vector[i - 1]) break;                        /* mark all thread  */
                    vector[i - 1] = 1;                               /* as nonprintable  */
                    if (!ENTRY(i)->next) break;                      /* if -tt and       */
                    i += ENTRY(i)->next;                             /* one thread entry */
                }while (t_flag && i && ENTRY(i)->th != th_root);     /* is printed       */
                i = bemail;                                          /********************/
                while (t_flag && i && ENTRY(i)->th != th_root)       /**/
                {   if (!ENTRY(i)->prev) break;                      /**/
                    i += ENTRY(i)->prev;                             /**/
                    if (vector[i - 1]) break;                        /**/
                    vector[i - 1] = 1;                               /**/
                };
    }       };
    if (munmap((void*)entries, (arcsize + db->header.len) * DB_BLOCK_SIZE)) perr(EX_IOERR, NULL);
    if (mail_opened) fclose(MAIL_F);
    fclose(DB_F);
    exit(EX_OK);
}
