/*
 * @BABOLO (C)1999, 2000 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: mescommon.h,v 1.2 2000/05/28 16:10:13 babolo Exp $
 *     $Name:  $
 */
#include "messarge.h"

const char months[][4] =
{"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"
,"","","","","","","","","","","",""
};
const char weekdays[][4] = {"Sun","Mon","Tue","Wen","Thu","Fri","Sat"};
const char weekrs[][3] = {"","","","","","",""};

FILE *DB_F, *MAIL_F, *NEW_F;
char *myname;
unsigned char mail_f_name[WORK_SIZE];
unsigned ListN, bemail, maxmail;
MASK_T ListM;
struct db *db;
struct db_entry *entries;
int filebdes, filemail, newbdes, blocksize;
unsigned messarge_version;
off_t arcsize;
enum open_m {read_m, readup_m, old_m, update_m};

void perr(int eval, const char *fmt)
{   fprintf(stderr, "%s: ", myname);
    perror(fmt);
    exit(eval);
};

MASK_T tomask(unsigned char *p)
{   MASK_T u = 0;
    int i;

    for (i = 0; i < db->header.LList; i++) u |= p[i] << (8 * i);
    return(u);
};

off_t open_db(char *name, enum open_m upd)
{   int errrr = 0, i, j = 5;
    struct stat sb, sb1;

begin:
    if (stat(name, &sb))                                                         perr(EX_NOINPUT, name);
    errrr = 1;
    if (upd == update_m)
    {    if ((filebdes = open(name, O_RDWR)) < 0)                                perr(EX_CANTCREAT, name);
         if (flock(filebdes, LOCK_EX))                                           perr(EX_IOERR, name);
         if ((DB_F = fdopen(filebdes, "a+")) == NULL)                            perr(EX_IOERR, name);
    }else
    {   if ((filebdes = open(name, O_RDONLY)) < 0)                               perr(EX_NOINPUT, name);
        if (flock(filebdes, LOCK_SH))                                            perr(EX_IOERR, name);
        if ((DB_F = fdopen(filebdes, "r")) == NULL)                              perr(EX_IOERR, name);
    };
    errrr = 10;
    if (fseek(DB_F, 0, SEEK_SET))                                                perr(EX_IOERR, name);
    bzero(&db->header, sizeof(struct db_header));
    (void)fread(&db->header, sizeof(struct db_header), 1, DB_F);
    errrr = 11;
    if (ferror(DB_F))                                                            perr(EX_IOERR, name);
    errrr = 12;
    if (ftell(DB_F) < sizeof(unsigned) * 4)                                      goto db_err;
    messarge_version = db->header.magic;
    errrr = 13;
    if (db->header.len < 1)                                                      goto db_err;
    switch(messarge_version) /* this is place for version converting code */
    {case MAGIK_00:
        errrr = 14;
        if (upd != old_m)                                                        goto db_err;
        blocksize =   (void*)((struct db_entry_00 *)(&db->entry))->var
                    - (void*)((struct db_entry_00 *)(&db->entry))
                    + db->header.var_size;
        errrr = 15;
        if (ftell(DB_F) < (void*)&db->header - (void*)&db->header.path[2])       goto db_err;
        db->header.magic = MAGIK_VV;
        break;
     case MAGIK_VV:
        blocksize = (void*)db->entry.var - (void*)&db->entry + db->header.var_size;
        errrr = 16;
        if (ftell(DB_F) < (void*)&db->header - (void*)&db->header.path[2])       goto db_err;
        break;
     default: errrr = 17;                                                        goto db_err;
    };
    if (ftell(DB_F) / blocksize < db->header.len)                                goto db_err;
    errrr = 21;
    if (sb.st_size % blocksize)                                                  goto db_err;
    errrr = 22;
    if (db->header.var_size < 4)                                                 goto db_err;
    errrr = 23;
    if (upd == readup_m && j-- && db->header.flags & MAKE_ON_WAKEUP)
    {   if (stat(db->header.path, &sb1))                                         perr(EX_NOINPUT, db->header.path);
        errrr = 30;
        if (sb.st_mtime < sb1.st_mtime)
        {   if (fclose(DB_F))                                                    goto db_err;
            errrr = 31;
            i = fork();
            if (i < 0)                                                           perr(EX_CONFIG, NULL);
            errrr = 32;
            if (i == 0)
            {   char *p, *dbc_name;
                dbc_name = malloc(strlen(myname) + strlen(MESRDBC));
                errrr = 50;
                if (!dbc_name) goto db_err;
                strcpy(dbc_name, myname);
                p = rindex(myname, '/');
                if (p) *(p + 1) = '\0';
                  else dbc_name[0] = '\0';
                strcat(dbc_name, MESRDBC);
                execlp(dbc_name, dbc_name, "-u", name, NULL);                    perr(EX_CONFIG, NULL);
            };
            (void)wait(&i);
            errrr = 33;
            if (!(WIFEXITED(i)))                                                 goto db_err;
            errrr = 34;
            if (WEXITSTATUS(i))                                                  goto db_err;
            goto begin;
    }   };
    if (fseek(DB_F, (long)DB_BLOCK_SIZE * db->header.len, SEEK_SET))             perr(EX_IOERR, name);
    return(sb.st_size);
db_err:
    fprintf(stderr, "Illegal DB %s, code = %d\n", name, errrr);                  exit(EX_DATAERR);
};

void exr(regex_t *preg, const char *pattern, int cflags)
{   int err;
    char buffer[132];

    if (!(err = regcomp(preg, pattern, cflags))) return;
    (void)regerror(err, preg, buffer, 132);
    fprintf(stderr, "%s: %s:%s\n", myname, pattern, buffer);
    exit(EX_SOFTWARE);
};
