/*
 * @BABOLO (C)1999, 2000 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: mesdbc.c,v 1.2 2000/05/28 16:10:13 babolo Exp $
 *     $Name:  $
 */
#include "mescommon.h"
#include "tables.h"

#define MAX_DELAY 64
#define CELL(a,b,c,d,e) automata[a][b + 1] = c; promata[a][b + 1] = d; hashtbl[a][b + 1] = e;
#define CELD(a,b,c,d,e) automata[a][b + 1] = c; promata[a][b + 1] = d; hashtbl[a][b + 1] = e; automata[a][b + 33] = c; promata[a][b + 33] = d; hashtbl[a][b + 33] = e;
#define CELC(a,b,c,d,e) celc(a,b,c,d,e)
#define STNM(a,b) (void)strncpy(statenames[a], b, STATE_NAME_LEN);

enum hstate {hs_none, hs_offed, hs_won, hs_oned, hs_woff};
enum state
{s_init,s_F  ,s_Fr  ,s_Fro  ,s_From
,s_body,s_bF ,s_bFr ,s_bFro ,s_bFrom
,s_hF  ,s_hFr,s_hFro,s_hFrom,s_hFrom_
,s_D   ,s_Da ,s_Dat ,s_Date ,s_Date_
,s_S   ,s_Su ,s_Sub ,s_Subj ,s_Subje ,s_Subjec ,s_Subject ,s_Subject_
,s_I   ,s_In ,s_In_ ,s_In_R ,s_In_Re ,s_In_Rep ,s_In_Repl ,s_In_Reply ,s_In_Reply_ ,s_In_Reply_T ,s_In_Reply_To ,s_In_Reply_To_
,s_M   ,s_Me ,s_Mes ,s_Mess ,s_Messa ,s_Messag ,s_Message ,s_Message_ ,s_Message_I ,s_Message_Id ,s_Message_Id_
,s_R   ,s_Re ,s_Ref ,s_Refe ,s_Refer ,s_Refere ,s_Referen ,s_Referenc ,s_Reference ,s_References ,s_References_
             ,s_Rep ,s_Repl ,s_Reply ,s_Reply_ ,s_Reply_T ,s_Reply_To ,s_Reply_To_
             ,s_Rec ,s_Rece ,s_Recei ,s_Receiv ,s_Receive ,s_Received ,s_Received_
,s_C   ,s_Co ,s_Con ,s_Cont ,s_Conte ,s_Conten ,s_Content ,s_Content_ ,s_Content_T ,s_Content_Ty ,s_Content_Typ ,s_Content_Type ,s_Content_Type_
                                                                                   ,s_Content_Tr ,s_Content_Tra ,s_Content_Tran ,s_Content_Trans ,s_Content_Transf ,s_Content_Transfe ,s_Content_Transfer ,s_Content_Transfer_ ,s_Content_Transfer_E ,s_Content_Transfer_En ,s_Content_Transfer_Enc ,s_Content_Transfer_Enco ,s_Content_Transfer_Encod ,s_Content_Transfer_Encodi ,s_Content_Transfer_Encodin ,s_Content_Transfer_Encoding ,s_Content_Transfer_Encoding_
,s_CT  ,s_CTm,s_CTmu,s_CTmul,s_CTmult,s_CTmulti,s_CTmultip,s_CTmultipa,s_CTmultipar,s_CTmultipart
             ,s_CTme,s_CTmes,s_CTmess,s_CTmessa,s_CTmessag,s_CTmessage
,s_CTMl,s_CTM
,s_CTMll
,s_CTM_      ,s_CTMb,s_CTMbo,s_CTMbou,s_CTMboun,s_CTMbound,s_CTMbounda,s_CTMboundar,s_CTMboundary,s_CTMboundary_
,s_CTMB
,s_header    ,s_headere     ,s_headers         ,s_end
,s_xxxx
};

char cpr[][4] =
{"EOF"
,"00"    ,"01"    ,"02"    ,"03"    ,"04"    ,"05"    ,"06"    ,"07"
,"08"    ,"\\t"   ,"\\n"   ,"0B"    ,"0C"    ,"\\r"   ,"0E"    ,"0F"
,"10"    ,"11"    ,"12"    ,"13"    ,"14"    ,"15"    ,"16"    ,"17"
,"18"    ,"19"    ,"1A"    ,"1B"    ,"1C"    ,"1D"    ,"1E"    ,"1F"
,"\\b"   ,"\'!\'" ,"\'\"\'","\'#\'" ,"\'$\'" ,"\'%\'" ,"\'&\'" ,"\'\'\'"
,"\'(\'" ,"\')\'" ,"\'*\'" ,"\'+\'" ,"\',\'" ,"\'-\'" ,"\'.\'" ,"\'/\'"
,"\'0\'" ,"\'1\'" ,"\'2\'" ,"\'3\'" ,"\'4\'" ,"\'5\'" ,"\'6\'" ,"\'7\'"
,"\'8\'" ,"\'9\'" ,"\':\'" ,"\';\'" ,"\'<\'" ,"\'=\'" ,"\'>\'" ,"\'?\'"
,"\'@\'" ,"\'A\'" ,"\'B\'" ,"\'C\'" ,"\'D\'" ,"\'E\'" ,"\'F\'" ,"\'G\'"
,"\'H\'" ,"\'I\'" ,"\'J\'" ,"\'K\'" ,"\'L\'" ,"\'M\'" ,"\'N\'" ,"\'O\'"
,"\'P\'" ,"\'Q\'" ,"\'R\'" ,"\'S\'" ,"\'T\'" ,"\'U\'" ,"\'V\'" ,"\'W\'"
,"\'X\'" ,"\'Y\'" ,"\'Z\'" ,"\'[\'" ,"\'\\\'","\']\'" ,"\'^\'" ,"\'_\'"
,"\'`\'" ,"\'a\'" ,"\'b\'" ,"\'c\'" ,"\'d\'" ,"\'e\'" ,"\'f\'" ,"\'g\'"
,"\'h\'" ,"\'i\'" ,"\'j\'" ,"\'k\'" ,"\'l\'" ,"\'m\'" ,"\'n\'" ,"\'o\'"
,"\'p\'" ,"\'q\'" ,"\'r\'" ,"\'s\'" ,"\'t\'" ,"\'u\'" ,"\'v\'" ,"\'w\'"
,"\'x\'" ,"\'y\'" ,"\'z\'" ,"\'{\'" ,"\'|\'" ,"\'}\'" ,"\'~\'" ,"7F"
,"80"    ,"81"    ,"82"    ,"83"    ,"84"    ,"85"    ,"86"    ,"87"
,"88"    ,"89"    ,"8A"    ,"8B"    ,"8C"    ,"8D"    ,"8E"    ,"8F"
,"90"    ,"91"    ,"92"    ,"93"    ,"94"    ,"95"    ,"96"    ,"97"
,"98"    ,"99"    ,"9A"    ,"9B"    ,"9C"    ,"9D"    ,"9E"    ,"9F"
,"A0"    ,"A1"    ,"A2"    ,"A3"    ,"A4"    ,"A5"    ,"A6"    ,"A7"
,"A8"    ,"A9"    ,"AA"    ,"AB"    ,"AC"    ,"AD"    ,"AE"    ,"AF"
,"B0"    ,"B1"    ,"B2"    ,"B3"    ,"B4"    ,"B5"    ,"B6"    ,"B7"
,"B8"    ,"B9"    ,"BA"    ,"BB"    ,"BC"    ,"BD"    ,"BE"    ,"BF"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'" ,"\'\'"
};

long position;
enum state state;
char delay[MAX_DELAY]; int delayp;
unsigned char buffer[WORK_SIZE]; int workp;
char subj[WORK_SIZE], from[WORK_SIZE], who[WORK_SIZE], id[WORK_SIZE], repl[WORK_SIZE];
regex_t date0_ex, date1_ex, from0_ex, from1_ex, from2_ex, from3_ex, from4_ex;
regex_t subj0_ex, subj1_ex, id_ex;
regex_t cod_ex, codk_ex, coda_ex, codw_ex, codi_ex;
regex_t cte0_ex, cte1_ex, cte2_ex, cte3_ex, cte4_ex, cte5_ex, cte6_ex;
regex_t ctyk_ex, ctya_ex, ctyw_ex, ctyi_ex, ctyh_ex;
regmatch_t pmatch[16];
struct tm tm;
int hashed, whashed, ready_to_write, v_flag, m_flag;
void (*do_)();

enum hstate hashtbl[s_xxxx][257];
enum state automata[s_xxxx][257];
void (*promata[s_xxxx][257])(int);
char statenames[s_xxxx][STATE_NAME_LEN];

void automata_print()
/********************************************************
 *
 * prints contents of control table of states of automata
 *
 ********************************************************/
{   int i;
    enum state j;

    for (j = s_init; j < s_xxxx; j++) fprintf(stderr," %03u %s\n", (unsigned)j, statenames[j]);
    fprintf(stderr," ");
    for (j = s_init; j < s_xxxx; j++) fprintf(stderr," %03u", (unsigned)j);
    fprintf(stderr,"\n");
    for (i = ' '; i <= 'z'; i++)
    {   fprintf(stderr,"\n%c", i);
        for (j = s_init; j < s_xxxx; j++)
        {   fprintf(stderr," %03u", (unsigned)(automata[j][i + 1]));
    }   };
    {   fprintf(stderr,"\nEOF");
        for (j = s_init; j < s_xxxx; j++)
        {   fprintf(stderr," %03u", (unsigned)automata[j][0]);
    }   };

    fprintf(stderr,"\n");
};

int nibble(unsigned char c)
{   const unsigned char code[] = "0123456789ABCDEF0123456789abcdef";
    int p;

    p = 0;
    while (code[p]) if (c == code[p]) return(p & 017); else p++;
    return(-1);
};

void recode(unsigned char **p, unsigned char c, enum code code)
{   int e = code & 0377 & ~CODEMASK;

    if (c && e < sizeof(tr) / sizeof(tr[0]))
        *(*p)++ = (c < 128 || e == no_code) ? c : tr[e - 1][c - 128];
};

void decode(unsigned char *buffer)
{   regmatch_t pmatch[2];
    unsigned char c, *p, *f;
    int step, i;
    enum code code;
    enum encapsulation encap;

    if (v_flag > 3) fprintf(stderr, "decode buffer=%s~\n", buffer);
    while (1)
    {   if (!regexec(&codk_ex, buffer, 2, pmatch, 0)) code = code_k;
        else if (!regexec(&coda_ex, buffer, 2, pmatch, 0)) code = code_a;
        else if (!regexec(&codw_ex, buffer, 2, pmatch, 0)) code = code_w;
        else if (!regexec(&codi_ex, buffer, 2, pmatch, 0)) code = code_i;
        else break;
        encap = (buffer[pmatch[1].rm_so] | 040) == 'b' ? base64 : quoted;
        if (v_flag > 3) fprintf(stderr, "code=%s, encapsulation=%s\n", code_names[code], encapsulation_names[encap]);
        p = &buffer[pmatch[0].rm_so];
        f = &buffer[pmatch[0].rm_eo];
        step = 0;
        if (encap == quoted)
        {   while (!step)
            {   switch (c = *f++)
                {case '\0':           ;                      ;              ; step++; break;
                 case '=' :
                    c = *f++;
                    while (c == ' ') c = *f++;
                    if (c == '\n')                                                    break;
                    if (nibble(c) < 0 || nibble(*f) < 0) {*p++ = '=';       ; step++; break;};
                    recode(&p, (nibble(c) << 4) + nibble(*f++), code & 0377);
                    break;
                 case '_' : *p++ = ' ';                      ;              ;         break;
                 case '?' : if ((c = *f++) != '=') *p++ = '?'; else c = *f++; step++; break;
                 case '\t':
                 case '\r':
                 case '\n': *p++ = c  ;                      ;              ;         break;
                 default  :
                    if (c < ' ')
                    {   if (v_flag) fprintf(stderr, "%s: Illegal Q char=%02X\n", myname, (unsigned)c);
                    }else recode(&p, c, code & 0377);
            }   }
        }else
        {   while ((c = *f++))
            {   if ((c >= 128) || (i = b64[c]) < -2) break;
                if (i < 0)
                {   if (v_flag) fprintf(stderr, "%s: Illegal B char=%02X\n", myname, (unsigned)c);
                }else
                {   i &= 077;
                    switch (step++ & 03)
                    {case 0:                               *p = i << 2; break;
                     case 1: recode(&p, *p | i >> 4, code & 0377); *p = i << 4; break;
                     case 2: recode(&p, *p | i >> 2, code & 0377); *p = i << 6; break;
                     case 3: recode(&p, *p | i     , code & 0377);              break;
                    };
                    if (b64[c] & 0300) break;
            }   };
            while (c == '=') c = *f++;
            if (c == '?')
            {   if ((c = *f++) == '=') c = *f++; else *p++ = '?';
        }   };
        while ((*p++ = c)) c = *f++;
}   };

void do_hash(unsigned long long *hash, int c)
/********************************************************************
 *
 * calculate hash function - cumulative round sum with shift in *hash
 *
 ********************************************************************/
{   int i;
    unsigned long long l1, l2;

    l1 = 1; l1 <<= 63;
    l2 = 0xFF; l2 = ~l2;
    for (i = 0; i < 7; i++)
        if (*hash & l1) *hash = (*hash << 1) + 1;
          else *hash = (*hash << 1);
    if ((*hash & l2) == l2)
    {   *hash += c;
        if (!(*hash & l1)) (*hash)++;
    }else *hash += c;
};

int getnext()
{   int c;

    c = getc(MAIL_F);
    delay[delayp++] = c;
    delayp %= MAX_DELAY; if (delayp < 0) delayp += MAX_DELAY;
    return(c);
};

int gethnext()
{   int c, p;

    c = getnext();
    if (hashed)
    {   whashed++;
        p = (delayp - whashed) % MAX_DELAY;
        if (p < 0) p += MAX_DELAY;
        while (whashed)
        {   do_hash(&db->entry.mail_hash, delay[p++]);
            p = p % MAX_DELAY;
            whashed--;
    }   };
    return(c);
};

void do_last(int c)
{   if (v_flag > 2) fprintf(stderr, ".do_last(%s)", cpr[c + 1]);
    while (c != EOF && c != '\n')
    {   if (workp < WORK_SIZE) buffer[workp++] = c;
        c = gethnext();
    };
    if (workp == WORK_SIZE) --workp;
    buffer[workp] = '\0';
    while (buffer[workp - 1] == ' ') buffer[--workp] = '\0';
    if (v_flag) fprintf(stderr, "%s=%s~\n", statenames[state], buffer);
};

void do_header(int c)
/****************************************************************
 *
 * Prepare string after 'Some-Header-Line: ' to parce in buffer[]
 *
 ****************************************************************/
{   if (v_flag > 2) fprintf(stderr, ".do_header(%s)", cpr[c + 1]);
    while (c != EOF && (c == ' ' || c == '\t')) c = gethnext();
    do_last(c);
};

void p_newline(int c)
{   if (v_flag > 2) fprintf(stderr, ".p_newline(%s)", cpr[c + 1]);
    position = ftell(MAIL_F);
};

void pr_line(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_line(%s)", cpr[c + 1]);
    if (do_) do_header(c);
    else
        while (c != EOF)
        {   if (c == '\n') break;
            c = gethnext();
        };
    p_newline(c);
};

void pr_lost(int x)
{   fprintf(stderr, "%s: Sync lost, position = %lu\n", myname, (unsigned long)(ftell(MAIL_F)));
    pr_line(x);
};

void pr_hdr(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_hdr(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = NULL; workp = 0; pr_line(c);
};

void do_rto()
/*************************************
 *
 * Parce 'Reply-To: ' string
 *
 *************************************/
{   int i;

    if (v_flag > 2) fprintf(stderr, ".do_rto()");
    if (!regexec(&from3_ex, buffer, 2, pmatch, 0))
    {   i = pmatch[1].rm_eo - pmatch[1].rm_so;
        if (v_flag) fprintf( stderr, "rto3=%s~\n",buffer);
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        bcopy(&buffer[pmatch[1].rm_so], from, i);
        from[i] = '\0';
        if (v_flag) fprintf(stderr, " from=%s~\n", from);
    }else if (!regexec(&from4_ex, buffer, 2, pmatch, 0))
    {   i = pmatch[1].rm_eo - pmatch[1].rm_so;
        if (v_flag) fprintf( stderr, "rto4=%s~\n",buffer);
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        bcopy(&buffer[pmatch[1].rm_so], from, i);
        from[i] = '\0';
        if (v_flag) fprintf(stderr, " from=%s~\n", from);
    }else
        if (v_flag) fprintf( stderr, "no rto=%s~\n",buffer);
    p_newline(0);
};

void pr_rto(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_rto(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_rto; workp = 0; do_header(c);
};

void do_from()
/*************************************
 *
 * Parce 'From: ' string
 *
 *************************************/
{   int i;

    if (v_flag > 2) fprintf(stderr, ".do_from()");
    decode(buffer);
    if (!regexec(&from0_ex, buffer, 2, pmatch, 0))
    {   i = pmatch[1].rm_eo - pmatch[1].rm_so;
        if (v_flag) fprintf( stderr, "from0=%s~\n",buffer);
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        if (!from[0])
        {   bcopy(&buffer[pmatch[1].rm_so], from, i);
            from[i] = '\0';
        };
        buffer[pmatch[0].rm_so] = '\0';
        strncpy(who, buffer, WORK_SIZE);
    }else if (!regexec(&from1_ex, buffer, 6, pmatch, 0))
    {   i = pmatch[1].rm_eo - pmatch[1].rm_so;
        if (v_flag) fprintf( stderr, "from1=%s~\n",buffer);
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        if (!from[0])
        {   bcopy(&buffer[pmatch[1].rm_so], from, i);
            from[i] = '\0';
        };
        i = pmatch[5].rm_eo - pmatch[5].rm_so;
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        bcopy(&buffer[pmatch[5].rm_so], who, i);
        who[i] = '\0';
    }else if (!regexec(&from2_ex, buffer, 2, pmatch, 0))
    {   i = pmatch[1].rm_eo - pmatch[1].rm_so;
        if (v_flag) fprintf( stderr, "from2=%s~\n",buffer);
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        if (!from[0])
        {   bcopy(&buffer[pmatch[1].rm_so], from, i);
            from[i] = '\0';
        };
    }else if (!regexec(&from3_ex, buffer, 2, pmatch, 0))
    {   i = pmatch[1].rm_eo - pmatch[1].rm_so;
        if (v_flag) fprintf( stderr, "from3=%s~\n",buffer);
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        if (!from[0])
        {   bcopy(&buffer[pmatch[1].rm_so], from, i);
            from[i] = '\0';
        };
        i = (strlen(&buffer[pmatch[0].rm_eo]) > pmatch[0].rm_so) ? pmatch[0].rm_eo : 0;
        buffer[pmatch[0].rm_so] = '\0';
        strncpy(who, &buffer[i], WORK_SIZE);
    }else if (!regexec(&from4_ex, buffer, 2, pmatch, 0))
    {   i = pmatch[1].rm_eo - pmatch[1].rm_so;
        if (v_flag) fprintf( stderr, "from4=%s~\n",buffer);
        if (i >= WORK_SIZE) i = WORK_SIZE - 1;
        if (!from[0])
        {   bcopy(&buffer[pmatch[1].rm_so], from, i);
            from[i] = '\0';
        };
        i = (strlen(&buffer[pmatch[0].rm_eo]) > pmatch[0].rm_so) ? pmatch[0].rm_eo : 0;
        buffer[pmatch[0].rm_so] = '\0';
        strncpy(who, &buffer[i], WORK_SIZE);
    }else
    {   if (v_flag) fprintf( stderr, "from not matched=%s~\n",buffer);
        strncpy(who, buffer, WORK_SIZE);
    };
    from[WORK_SIZE - 1] = '\0';
    who[WORK_SIZE - 1] = '\0';
    if (v_flag) fprintf(stderr, " from=%s~, who=%s~\n", from, who);
    p_newline(0);
};

void pr_from(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_from(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_from; workp = 0; do_header(c);
};

void do_subj()
/*************************************
 *
 * Parce 'Subject: ' string
 *
 *************************************/
{   int i;

    if (v_flag > 2) fprintf(stderr, ".do_subj()");
    decode(buffer);
    bzero(subj, WORK_SIZE);
    strncpy(subj, buffer, WORK_SIZE);
    subj[WORK_SIZE-1] = '\0';
    if (!regexec(&subj0_ex, buffer, 1, pmatch, 0)) buffer[pmatch[0].rm_so] = '\0';
    i = regexec(&subj1_ex, buffer, 1, pmatch, 0) ? 0 : pmatch[0].rm_eo;
    if (v_flag) fprintf( stderr, " subj=%s~\n",&buffer[i]);
    db->entry.subj_hash = 0;
    while (buffer[i]) do_hash(&db->entry.subj_hash, buffer[i++]);
    p_newline(0);
};

void pr_subj(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_subj(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_subj; workp = 0; do_header(c);
};

void do_repl()
{   int i;

    if (v_flag > 2) fprintf(stderr, ".do_repl()");
    if (regexec(&id_ex, buffer, 2, pmatch, 0))
    {   if (v_flag) fprintf(stderr, "REJECT\n");
    }else
    {   db->entry.repl_hash = 0;
        for (i = pmatch[1].rm_so; i < pmatch[1].rm_eo; i++)
            do_hash(&db->entry.repl_hash, buffer[i]);
}   };

void pr_repl(int c)
{   if (v_flag > 2) fprintf(stderr, ".do_last(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_repl; workp = 0; do_header(c);
};

void do_id()
{   int i;

    if (v_flag > 2) fprintf(stderr, ".do_id()");
    if (regexec(&id_ex, buffer, 2, pmatch, 0))
    {   if (v_flag) fprintf(stderr, "REJECT\n");
    }else
    {   db->entry.id_hash = 0;
        for (i = pmatch[1].rm_so; i < pmatch[1].rm_eo; i++)
            do_hash(&db->entry.id_hash, buffer[i]);
}   };

void pr_id(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_id(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_id; workp = 0; do_header(c);
};

void do_date()
/*************************************
 *
 * Parce 'Date: ' string
 *
 *************************************/
{   int i;

    if (v_flag > 2) fprintf(stderr, ".do_date()");
    tm.tm_isdst = -1;
    if (!regexec(&date0_ex, buffer, 12, pmatch, 0))
    {   tm.tm_mday = atoi(&buffer[pmatch[1].rm_so]);
        tm.tm_mon = -1;
        i = atoi(&buffer[pmatch[3].rm_so]);
        switch (pmatch[3].rm_eo - pmatch[3].rm_so)
        {case 2: if (i >= 70) i += 900;
         case 3: i += (i >= 900) ? 1000 : 2000;
         case 4: i -= 1900;
        };
        tm.tm_year = i;
        tm.tm_hour = atoi(&buffer[pmatch[4].rm_so]);
        tm.tm_min = atoi(&buffer[pmatch[5].rm_so]);
        tm.tm_sec = atoi(&buffer[pmatch[7].rm_so]);
        i = atoi(&buffer[pmatch[11].rm_so]);
        buffer[pmatch[11].rm_so] = '\0';
        if (buffer[pmatch[9].rm_so] == '-')
        {   tm.tm_min += i;
            tm.tm_hour += atoi(&buffer[pmatch[10].rm_so]);
        }else
        {   tm.tm_min -= i;
            tm.tm_hour -= atoi(&buffer[pmatch[10].rm_so]);
        };

        for (i = 0; i < 24; i++)
            if (!strncasecmp(&buffer[pmatch[2].rm_so], months[i], 3))
            {   tm.tm_mon = i % 12;
                break;
            };
        if (v_flag) fprintf( stderr, "date0=%s~\n",buffer);
        if (tm.tm_mon == -1)
        {   if (v_flag) fprintf( stderr
                               , "Illegal month %c%c%c\n"
                               , buffer[pmatch[2].rm_so]
                               , buffer[pmatch[2].rm_so + 1]
                               , buffer[pmatch[2].rm_so + 2]
                               );
        }else
        {   db->entry.mail_time = mktime(&tm);
            if (v_flag) fprintf(stderr, "      %s", ctime(&db->entry.mail_time));
        };
    }else if (!regexec(&date1_ex, buffer, 12, pmatch, 0))
    {   tm.tm_mday = atoi(&buffer[pmatch[2].rm_so]);
        tm.tm_mon = -1;
        i = atoi(&buffer[pmatch[3].rm_so]);
        switch (pmatch[3].rm_eo - pmatch[3].rm_so)
        {case 2: if (i >= 70) i += 900;
         case 3: i += (i >= 900) ? 1000 : 2000;
         case 4: i -= 1900;
        };
        tm.tm_year = i;
        tm.tm_hour = atoi(&buffer[pmatch[4].rm_so]);
        tm.tm_min = atoi(&buffer[pmatch[5].rm_so]);
        tm.tm_sec = atoi(&buffer[pmatch[7].rm_so]);
        i = atoi(&buffer[pmatch[11].rm_so]);
        buffer[pmatch[11].rm_so] = '\0';
        if (buffer[pmatch[9].rm_so] == '-')
        {   tm.tm_min += i;
            tm.tm_hour += atoi(&buffer[pmatch[10].rm_so]);
        }else
        {   tm.tm_min -= i;
            tm.tm_hour -= atoi(&buffer[pmatch[10].rm_so]);
        };

        for (i = 0; i < 24; i++)
            if (!strncasecmp(&buffer[pmatch[1].rm_so], months[i], 3))
            {   tm.tm_mon = i % 12;
                break;
            };
        if (v_flag) fprintf( stderr, "date1=%s~\n",buffer);
        if (tm.tm_mon == -1)
        {   if (v_flag) fprintf( stderr
                               , "Illegal month %c%c%c\n"
                               , buffer[pmatch[2].rm_so]
                               , buffer[pmatch[2].rm_so + 1]
                               , buffer[pmatch[2].rm_so + 2]
                               );
        }else
        {   db->entry.mail_time = mktime(&tm);
            if (v_flag) fprintf(stderr, "      %s", ctime(&db->entry.mail_time));
        };
    }else
    {   if (v_flag) fprintf( stderr, "Illegal data format: %s\n", buffer);
    };
    p_newline(0);
};

void pr_date(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_date(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_date; workp = 0; do_header(c);
};

void do_cte()
{   if (v_flag > 2) fprintf(stderr, ".do_cte()");
    if      (!regexec(&cte0_ex, buffer, 0, pmatch, 0)) db->entry.encapsulation = bit7;
    else if (!regexec(&cte1_ex, buffer, 0, pmatch, 0)) db->entry.encapsulation = bit8;
    else if (!regexec(&cte2_ex, buffer, 0, pmatch, 0)) db->entry.encapsulation = binary;
    else if (!regexec(&cte3_ex, buffer, 0, pmatch, 0)) db->entry.encapsulation = quoted;
    else if (!regexec(&cte4_ex, buffer, 0, pmatch, 0)) db->entry.encapsulation = base64;
    else if (!regexec(&cte5_ex, buffer, 0, pmatch, 0)) db->entry.encapsulation = uu;
    else if (!regexec(&cte6_ex, buffer, 0, pmatch, 0)) db->entry.encapsulation = uu;
    else db->entry.encapsulation = none_enc;
    if (v_flag) fprintf(stderr, "encapsulation = %s\n", encapsulation_names[db->entry.encapsulation & 0377]);
};

void pr_cte(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_cte(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_cte; workp = 0; do_header(c);
};

void do_cty()
{   if (v_flag > 2) fprintf(stderr, ".do_cty()");
    if      (!regexec(&ctyk_ex, buffer, 0, pmatch, 0)) code = code_k;
    else if (!regexec(&ctya_ex, buffer, 0, pmatch, 0)) code = code_a;
    else if (!regexec(&ctyw_ex, buffer, 0, pmatch, 0)) code = code_w;
    else if (!regexec(&ctyi_ex, buffer, 0, pmatch, 0)) code = code_i;
    else if (regexec(&cod_ex, buffer, 0, pmatch, 0)) code = code_unknown;
    if (!regexec(&ctyh_ex, buffer, 0, pmatch, 0)) code |= CODEMASK;
    if (v_flag) fprintf(stderr, "code = %s", code_names[code & 0377 & ~CODEMASK]);
    if (v_flag && code & CODEMASK) fprintf(stderr, "(html)");
    if (v_flag) fprintf(stderr, "\n");
};

void pr_(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = NULL;
};

void pr_last(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_last(%s)", cpr[c + 1]);
    do_last(c);
};

void pr_cty(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_cty(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = do_cty; workp = 0;
};

void pr_ct(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_ct(%s)", cpr[c + 1]);
    if (workp < WORK_SIZE) buffer[workp++] = c;
};

void pr_ctb(int c)
{   int i, j;
    unsigned char *p;

    if (v_flag > 2) fprintf(stderr, ".pr_ctb(%s)", cpr[c + 1]);
    j = workp;
    db->entry.bound = ftell(MAIL_F) - db->entry.offset - 1;
    do_last(c);
    if (v_flag > 1) fprintf(stderr, "Boundary=%s~\n", &buffer[j]);
    if (c == '\"')
    {   j++; db->entry.bound++;
        p = index(&buffer[j], '\"');
        if (v_flag > 1 && p)
        {   fprintf(stderr, "\" found   ");
            for (i = 0; i < (void*)p - (void*)(&buffer[j]); i++) fprintf(stderr, " ");
            fprintf(stderr, "^\n");
        };
        if (!p)
        {   p = index(&buffer[j], '\0');
            if (v_flag > 1 && p)
            {   fprintf(stderr, "\\0 found  ");
                for (i = 0; i < (void*)p - (void*)(&buffer[j]); i++) fprintf(stderr, " ");
                fprintf(stderr, "^\n");
        }   };
        i = p ? (void*)p - (void*)(&buffer[j]) : 0;
    }else
    {   i = strspn( &buffer[j]
                  , "-!#$%&\'*+.^_`{|}~"
                    "0123456789"
                    "ABCDEFGHIJKLMNOPQRSTUVWXYZ"
                    "abcdefghijklmnopqrstuvwxyz"
                   ""
                   ""
                  );
    };
    db->entry.boundl = i < 256 ? i : 255;
    if (v_flag)
    {   fprintf(stderr, "Stored boundary=");
        for (i = 0; i < db->entry.boundl; i++) fprintf(stderr, "%c", buffer[j + i]);
        fprintf(stderr, "~\n");
}   };

void pr_compo(int c)
/********************************************************
 *
 * prepare DB entry exept mail_hash - do it at end of mail
 *
 *********************************************************/
{   unsigned char *p;
    int i;

    if (v_flag > 2) fprintf(stderr, ".pr_compo(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = NULL; workp = 0;
    db->entry.headerl = ftell(MAIL_F) - db->entry.offset;
    for (i = 0; i < db->header.LList; i++)
        db->entry.var[i] = ListM >> (8 * i);
    db->entry.charset = code;
    db->entry.next = db->entry.prev = 0;
    db->entry.th = db->entry.right = 0;
    db->entry.plex = db->entry.lext = 0;
    p = db->entry.var + db->header.LList;         /* VAR_STR */
    strncpy(p, from, db->entry.var - p + db->header.var_size);
    db->entry.var[db->header.var_size - 1] = '\0';
    p = index(p, '\0'); p++;
    strncpy(p, who, db->entry.var - p + db->header.var_size);
    db->entry.var[db->header.var_size - 1] = '\0';
    p = index(p, '\0'); p++;
    strncpy(p, subj, db->entry.var - p + db->header.var_size);
    db->entry.var[db->header.var_size - 1] = '\0';
    p_newline(c);
    ready_to_write++;
};

void pr_write(int c)
{   if (v_flag > 2) fprintf(stderr, ".pr_write(%s)", cpr[c + 1]);
    db->entry.bodyl = position - db->entry.offset;
    if (1 != fwrite(&db->entry, DB_BLOCK_SIZE, 1, DB_F))          perr(EX_IOERR, NULL);
    ready_to_write = 0;
};

void pr_F_(int c)
/****************************************************************
 *
 * 'From ' detected - save previous DB entry and prepare new entry
 *
 *****************************************************************/
{   if (v_flag > 2) fprintf(stderr, ".pr_F_(%s)", cpr[c + 1]);
    if (do_) do_(); do_ = NULL; workp = 0;
    if (ready_to_write) pr_write(0);
    bzero(&db->entry, DB_BLOCK_SIZE);
    db->entry.offset = position;
    db->entry.stored_time = time(NULL);
    code = no_code;
    db->entry.encapsulation = none_enc;
    bzero(subj, WORK_SIZE); 
    bzero(from, WORK_SIZE); 
    bzero(who, WORK_SIZE); 
    bzero(id, WORK_SIZE); 
    bzero(repl, WORK_SIZE); 
    pr_line(0);
};

void celc(enum state a, unsigned char *b, enum state c, void (*d)(), enum hstate e)
{   unsigned i;
    unsigned char t[] = "-!#$%&\'*+.^_`{|}~";

    while (*b)
        switch(i = *b++)
        {case 'a':
            for (i = 0; i < 256; i++)
            {   automata[a][i + 1] = c;
                promata[a][i + 1] = d;
                hashtbl[a][i + 1] = e;
            };  break;
         case 'n':
            for (i = '0'; i <= '9'; i++)
            {   automata[a][i + 1] = c;
                promata[a][i + 1] = d;
                hashtbl[a][i + 1] = e;
            };  break;
         case 'l':
            for (i = 'A'; i <= 'Z'; i++)
            {   automata[a][i + 1] = c;
                automata[a][i + 33] = c;
                promata[a][i + 1] = d;
                promata[a][i + 33] = d;
                hashtbl[a][i + 1] = e;
                hashtbl[a][i + 33] = e;
            };  break;
         case 'r':
            for (i = (unsigned)''; i <= (unsigned)''; i++)
            {   automata[a][(i & 0377) + 1] = c;
                automata[a][(i & 0377) + 33] = c;
                promata[a][(i & 0377) + 1] = d;
                promata[a][(i & 0377) + 33] = d;
                hashtbl[a][(i & 0377) + 1] = e;
                hashtbl[a][(i & 0377) + 33] = e;
            };  break;
         case 't':
            for (i = 0; t[i]; i++)
            {   automata[a][(t[i] & 0377) + 1] = c;
                promata[a][(t[i] & 0377) + 1] = d;
                hashtbl[a][(t[i] & 0377) + 1] = e;
            };  break;
         default:
            automata[a][i + 1] = c;
            promata[a][i + 1] = d;
            hashtbl[a][i + 1] = e;
            if ('A' < i && i < 'Z')
            {   automata[a][i + 33] = c;
                promata[a][i + 33] = d;
                hashtbl[a][i + 33] = e;
}       }   };

void automata_init()
{   int i;
    enum state j;

    for (j = s_init; j < s_xxxx; j++)
    {   for (i = 0; i < 257; i++)
        {   promata[j][i] = pr_line;
            automata[j][i] = s_headere;
            hashtbl[j][i] = hs_none;
    }   };
    for (j = s_init; j < s_xxxx; j++)
    {   promata [j]['\n' + 1] = p_newline;
        automata[j][0] = s_end;
        promata [j][0] = pr_F_;
        hashtbl [j][0] = hs_offed;
    };

    CELC(s_init                      ,"a"   ,s_init                      ,pr_lost  ,hs_offed);
    CELC(s_F                         ,"a"   ,s_init                      ,pr_lost  ,hs_none);
    CELC(s_Fr                        ,"a"   ,s_init                      ,pr_lost  ,hs_none);
    CELC(s_Fro                       ,"a"   ,s_init                      ,pr_lost  ,hs_none);
    CELC(s_From                      ,"a"   ,s_init                      ,pr_lost  ,hs_none);
    CELC(s_body                      ,"a"   ,s_body                      ,pr_line  ,hs_none);
    CELC(s_bF                        ,"a"   ,s_body                      ,pr_line  ,hs_none);
    CELC(s_bFr                       ,"a"   ,s_body                      ,pr_line  ,hs_none);
    CELC(s_bFro                      ,"a"   ,s_body                      ,pr_line  ,hs_none);
    CELC(s_bFrom                     ,"a"   ,s_body                      ,pr_line  ,hs_none);
    CELL(s_init                      ,'F'   ,s_F                         ,NULL     ,hs_offed);
    CELL(s_F                         ,'r'   ,s_Fr                        ,NULL     ,hs_offed);
    CELL(s_Fr                        ,'o'   ,s_Fro                       ,NULL     ,hs_offed);
    CELL(s_Fro                       ,'m'   ,s_From                      ,NULL     ,hs_offed);
    CELL(s_From                      ,' '   ,s_headere                   ,pr_F_    ,hs_offed);
    CELL(s_body                      ,'\n'  ,s_body                      ,p_newline,hs_none);
    CELL(s_body                      ,'F'   ,s_bF                        ,NULL     ,hs_woff);
    CELL(s_bF                        ,'r'   ,s_bFr                       ,NULL     ,hs_woff);
    CELL(s_bFr                       ,'o'   ,s_bFro                      ,NULL     ,hs_woff);
    CELL(s_bFro                      ,'m'   ,s_bFrom                     ,NULL     ,hs_woff);
    CELL(s_bFrom                     ,' '   ,s_headere                   ,pr_F_    ,hs_offed);
    CELC(s_headere                   ," \t" ,s_headere                   ,pr_line  ,hs_none);
    CELC(s_headere                   ,"tnlr",s_header                    ,pr_      ,hs_won);
    CELC(s_CTMl                      ,"tnlr",s_header                    ,pr_      ,hs_won);
    CELC(s_header                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELL(s_header                    ,':'   ,s_headers                   ,NULL     ,hs_won);
    CELL(s_headers                   ,' '   ,s_headere                   ,pr_hdr   ,hs_oned);
    CELL(s_headere                   ,'\n'  ,s_body                      ,pr_compo ,hs_oned);
    CELL(s_CTMl                      ,'\n'  ,s_body                      ,pr_compo ,hs_oned);
    CELD(s_headere                   ,'F'   ,s_hF                        ,pr_      ,hs_won);
    CELD(s_CTMl                      ,'F'   ,s_hF                        ,pr_      ,hs_won);
    CELC(s_hF                        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_hFr                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_hFro                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_hFrom                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELD(s_hF                        ,'R'   ,s_hFr                       ,NULL     ,hs_won);
    CELD(s_hFr                       ,'O'   ,s_hFro                      ,NULL     ,hs_won);
    CELD(s_hFro                      ,'M'   ,s_hFrom                     ,NULL     ,hs_won);
    CELL(s_hFrom                     ,':'   ,s_hFrom_                    ,NULL     ,hs_won);
    CELL(s_hFrom_                    ,' '   ,s_headere                   ,pr_from  ,hs_oned);
    CELD(s_headere                   ,'D'   ,s_D                         ,pr_      ,hs_won);
    CELD(s_CTMl                      ,'D'   ,s_D                         ,pr_      ,hs_won);
    CELC(s_D                         ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Da                        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Dat                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Date                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELD(s_D                         ,'A'   ,s_Da                        ,NULL     ,hs_won);
    CELD(s_Da                        ,'T'   ,s_Dat                       ,NULL     ,hs_won);
    CELD(s_Dat                       ,'E'   ,s_Date                      ,NULL     ,hs_won);
    CELL(s_Date                      ,':'   ,s_Date_                     ,NULL     ,hs_won);
    CELL(s_Date_                     ,' '   ,s_headere                   ,pr_date  ,hs_oned);
    CELD(s_headere                   ,'S'   ,s_S                         ,pr_      ,hs_won);
    CELD(s_CTMl                      ,'S'   ,s_S                         ,pr_      ,hs_won);
    CELC(s_S                         ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Su                        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Sub                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Subj                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Subje                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Subjec                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Subject                   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELD(s_S                         ,'U'   ,s_Su                        ,NULL     ,hs_won);
    CELD(s_Su                        ,'B'   ,s_Sub                       ,NULL     ,hs_won);
    CELD(s_Sub                       ,'J'   ,s_Subj                      ,NULL     ,hs_won);
    CELD(s_Subj                      ,'E'   ,s_Subje                     ,NULL     ,hs_won);
    CELD(s_Subje                     ,'C'   ,s_Subjec                    ,NULL     ,hs_won);
    CELD(s_Subjec                    ,'T'   ,s_Subject                   ,NULL     ,hs_won);
    CELL(s_Subject                   ,':'   ,s_Subject_                  ,NULL     ,hs_won);
    CELL(s_Subject_                  ,' '   ,s_headere                   ,pr_subj  ,hs_oned);
    CELD(s_headere                   ,'M'   ,s_M                         ,pr_      ,hs_won);
    CELD(s_CTMl                      ,'M'   ,s_M                         ,pr_      ,hs_won);
    CELC(s_M                         ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Me                        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Mes                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Mess                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Messa                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Messag                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Message                   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Message_                  ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Message_I                 ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Message_Id                ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELD(s_M                         ,'E'   ,s_Me                        ,NULL     ,hs_won);
    CELD(s_Me                        ,'S'   ,s_Mes                       ,NULL     ,hs_won);
    CELD(s_Mes                       ,'S'   ,s_Mess                      ,NULL     ,hs_won);
    CELD(s_Mess                      ,'A'   ,s_Messa                     ,NULL     ,hs_won);
    CELD(s_Messa                     ,'G'   ,s_Messag                    ,NULL     ,hs_won);
    CELD(s_Messag                    ,'E'   ,s_Message                   ,NULL     ,hs_won);
    CELL(s_Message                   ,'-'   ,s_Message_                  ,NULL     ,hs_won);
    CELD(s_Message_                  ,'I'   ,s_Message_I                 ,NULL     ,hs_won);
    CELD(s_Message_I                 ,'D'   ,s_Message_Id                ,NULL     ,hs_won);
    CELL(s_Message_Id                ,':'   ,s_Message_Id_               ,NULL     ,hs_won);
    CELL(s_Message_Id_               ,' '   ,s_headere                   ,pr_id    ,hs_oned);
    CELD(s_headere                   ,'R'   ,s_R                         ,pr_      ,hs_won);
    CELD(s_CTMl                      ,'R'   ,s_R                         ,pr_      ,hs_won);
    CELC(s_R                         ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Re                        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Rec                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Rece                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Recei                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Receiv                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Receive                   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Received                  ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Rep                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Repl                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Reply                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Reply_                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Reply_T                   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Reply_To                  ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Ref                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Refe                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Refer                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Refere                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Referen                   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Referenc                  ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Reference                 ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_References                ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELD(s_R                         ,'E'   ,s_Re                        ,NULL     ,hs_won);
    CELD(s_Re                        ,'C'   ,s_Rec                       ,NULL     ,hs_won);
    CELD(s_Rec                       ,'E'   ,s_Rece                      ,NULL     ,hs_won);
    CELD(s_Rece                      ,'I'   ,s_Recei                     ,NULL     ,hs_won);
    CELD(s_Recei                     ,'V'   ,s_Receiv                    ,NULL     ,hs_won);
    CELD(s_Receiv                    ,'E'   ,s_Receive                   ,NULL     ,hs_won);
    CELD(s_Receive                   ,'D'   ,s_Received                  ,NULL     ,hs_won);
    CELD(s_Received                  ,':'   ,s_Received_                 ,NULL     ,hs_won);
    CELD(s_Received_                 ,' '   ,s_headere                   ,pr_hdr   ,hs_none);
    CELD(s_Re                        ,'P'   ,s_Rep                       ,NULL     ,hs_won);
    CELD(s_Rep                       ,'L'   ,s_Repl                      ,NULL     ,hs_won);
    CELD(s_Repl                      ,'Y'   ,s_Reply                     ,NULL     ,hs_won);
    CELL(s_Reply                     ,'-'   ,s_Reply_                    ,NULL     ,hs_won);
    CELD(s_Reply_                    ,'T'   ,s_Reply_T                   ,NULL     ,hs_won);
    CELD(s_Reply_T                   ,'O'   ,s_Reply_To                  ,NULL     ,hs_won);
    CELL(s_Reply_To                  ,':'   ,s_Reply_To_                 ,NULL     ,hs_won);
    CELL(s_Reply_To_                 ,' '   ,s_headere                   ,pr_rto   ,hs_oned);
    CELD(s_Re                        ,'F'   ,s_Ref                       ,NULL     ,hs_won);
    CELD(s_Ref                       ,'E'   ,s_Refe                      ,NULL     ,hs_won);
    CELD(s_Refe                      ,'R'   ,s_Refer                     ,NULL     ,hs_won);
    CELD(s_Refer                     ,'E'   ,s_Refere                    ,NULL     ,hs_won);
    CELD(s_Refere                    ,'N'   ,s_Referen                   ,NULL     ,hs_won);
    CELD(s_Referen                   ,'C'   ,s_Referenc                  ,NULL     ,hs_won);
    CELD(s_Referenc                  ,'E'   ,s_Reference                 ,NULL     ,hs_won);
    CELD(s_Reference                 ,'S'   ,s_References                ,NULL     ,hs_won);
    CELL(s_References                ,':'   ,s_References_               ,NULL     ,hs_won);
    CELL(s_References_               ,' '   ,s_headere                   ,pr_repl  ,hs_oned);
    CELD(s_headere                   ,'I'   ,s_I                         ,pr_      ,hs_won);
    CELD(s_CTMl                      ,'I'   ,s_I                         ,pr_      ,hs_won);
    CELC(s_I                         ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In                        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_R                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_Re                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_Rep                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_Repl                   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_Reply                  ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_Reply_                 ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_Reply_T                ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_In_Reply_To               ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELD(s_I                         ,'N'   ,s_In                        ,NULL     ,hs_won);
    CELL(s_In                        ,'-'   ,s_In_                       ,NULL     ,hs_won);
    CELD(s_In_                       ,'R'   ,s_In_R                      ,NULL     ,hs_won);
    CELD(s_In_R                      ,'E'   ,s_In_Re                     ,NULL     ,hs_won);
    CELD(s_In_Re                     ,'P'   ,s_In_Rep                    ,NULL     ,hs_won);
    CELD(s_In_Rep                    ,'L'   ,s_In_Repl                   ,NULL     ,hs_won);
    CELD(s_In_Repl                   ,'Y'   ,s_In_Reply                  ,NULL     ,hs_won);
    CELL(s_In_Reply                  ,'-'   ,s_In_Reply_                 ,NULL     ,hs_won);
    CELD(s_In_Reply_                 ,'T'   ,s_In_Reply_T                ,NULL     ,hs_won);
    CELD(s_In_Reply_T                ,'O'   ,s_In_Reply_To               ,NULL     ,hs_won);
    CELL(s_In_Reply_To               ,':'   ,s_In_Reply_To_              ,NULL     ,hs_won);
    CELL(s_In_Reply_To_              ,' '   ,s_headere                   ,pr_repl  ,hs_oned);
    CELD(s_headere                   ,'C'   ,s_C                         ,pr_      ,hs_won);
    CELD(s_CTMl                      ,'C'   ,s_C                         ,pr_      ,hs_won);
    CELC(s_C                         ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Co                        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Con                       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Cont                      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Conte                     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Conten                    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content                   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_                  ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_T                 ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Tr                ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Tra               ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Tran              ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Trans             ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transf            ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfe           ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer          ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_         ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_E        ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_En       ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_Enc      ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_Enco     ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_Encod    ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_Encodi   ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_Encodin  ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Transfer_Encoding ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Ty                ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Typ               ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELC(s_Content_Type              ,"tnlr",s_header                    ,NULL     ,hs_won);
    CELD(s_C                         ,'O'   ,s_Co                        ,NULL     ,hs_won);
    CELD(s_Co                        ,'N'   ,s_Con                       ,NULL     ,hs_won);
    CELD(s_Con                       ,'T'   ,s_Cont                      ,NULL     ,hs_won);
    CELD(s_Cont                      ,'E'   ,s_Conte                     ,NULL     ,hs_won);
    CELD(s_Conte                     ,'N'   ,s_Conten                    ,NULL     ,hs_won);
    CELD(s_Conten                    ,'T'   ,s_Content                   ,NULL     ,hs_won);
    CELL(s_Content                   ,'-'   ,s_Content_                  ,NULL     ,hs_won);
    CELD(s_Content_                  ,'T'   ,s_Content_T                 ,NULL     ,hs_won);
    CELD(s_Content_T                 ,'R'   ,s_Content_Tr                ,NULL     ,hs_won);
    CELD(s_Content_Tr                ,'A'   ,s_Content_Tra               ,NULL     ,hs_won);
    CELD(s_Content_Tra               ,'N'   ,s_Content_Tran              ,NULL     ,hs_won);
    CELD(s_Content_Tran              ,'S'   ,s_Content_Trans             ,NULL     ,hs_won);
    CELD(s_Content_Trans             ,'F'   ,s_Content_Transf            ,NULL     ,hs_won);
    CELD(s_Content_Transf            ,'E'   ,s_Content_Transfe           ,NULL     ,hs_won);
    CELD(s_Content_Transfe           ,'R'   ,s_Content_Transfer          ,NULL     ,hs_won);
    CELL(s_Content_Transfer          ,'-'   ,s_Content_Transfer_         ,NULL     ,hs_won);
    CELD(s_Content_Transfer_         ,'E'   ,s_Content_Transfer_E        ,NULL     ,hs_won);
    CELD(s_Content_Transfer_E        ,'N'   ,s_Content_Transfer_En       ,NULL     ,hs_won);
    CELD(s_Content_Transfer_En       ,'C'   ,s_Content_Transfer_Enc      ,NULL     ,hs_won);
    CELD(s_Content_Transfer_Enc      ,'O'   ,s_Content_Transfer_Enco     ,NULL     ,hs_won);
    CELD(s_Content_Transfer_Enco     ,'D'   ,s_Content_Transfer_Encod    ,NULL     ,hs_won);
    CELD(s_Content_Transfer_Encod    ,'I'   ,s_Content_Transfer_Encodi   ,NULL     ,hs_won);
    CELD(s_Content_Transfer_Encodi   ,'N'   ,s_Content_Transfer_Encodin  ,NULL     ,hs_won);
    CELD(s_Content_Transfer_Encodin  ,'G'   ,s_Content_Transfer_Encoding ,NULL     ,hs_won);
    CELL(s_Content_Transfer_Encoding ,':'   ,s_Content_Transfer_Encoding_,NULL     ,hs_won);
    CELL(s_Content_Transfer_Encoding_,' '   ,s_headere                   ,pr_cte   ,hs_oned);
    CELD(s_Content_T                 ,'Y'   ,s_Content_Ty                ,NULL     ,hs_won);
    CELD(s_Content_Ty                ,'P'   ,s_Content_Typ               ,NULL     ,hs_won);
    CELD(s_Content_Typ               ,'E'   ,s_Content_Type              ,NULL     ,hs_won);
    CELL(s_Content_Type              ,':'   ,s_Content_Type_             ,NULL     ,hs_won);
    CELL(s_Content_Type_             ,' '   ,s_CT                        ,pr_cty   ,hs_oned);
    CELC(s_CT                        ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTm                       ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmu                      ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmul                     ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmult                    ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmulti                   ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmultip                  ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmultipa                 ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmultipar                ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmultipart               ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTme                      ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmes                     ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmess                    ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmessa                   ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmessag                  ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CTmessage                 ,"nlr-",s_headere                   ,pr_last  ,hs_none);
    CELC(s_CT                        ," \t" ,s_CT                        ,NULL     ,hs_none);
    CELD(s_CT                        ,'M'   ,s_CTm                       ,pr_ct    ,hs_none);
    CELD(s_CTm                       ,'U'   ,s_CTmu                      ,pr_ct    ,hs_none);
    CELD(s_CTmu                      ,'L'   ,s_CTmul                     ,pr_ct    ,hs_none);
    CELD(s_CTmul                     ,'T'   ,s_CTmult                    ,pr_ct    ,hs_none);
    CELD(s_CTmult                    ,'I'   ,s_CTmulti                   ,pr_ct    ,hs_none);
    CELD(s_CTmulti                   ,'P'   ,s_CTmultip                  ,pr_ct    ,hs_none);
    CELD(s_CTmultip                  ,'A'   ,s_CTmultipa                 ,pr_ct    ,hs_none);
    CELD(s_CTmultipa                 ,'R'   ,s_CTmultipar                ,pr_ct    ,hs_none);
    CELD(s_CTmultipar                ,'T'   ,s_CTmultipart               ,pr_ct    ,hs_none);
    CELL(s_CTmultipart               ,'/'   ,s_CTM                       ,pr_ct    ,hs_none);
    CELD(s_CTm                       ,'E'   ,s_CTme                      ,pr_ct    ,hs_none);
    CELD(s_CTme                      ,'S'   ,s_CTmes                     ,pr_ct    ,hs_none);
    CELD(s_CTmes                     ,'S'   ,s_CTmess                    ,pr_ct    ,hs_none);
    CELD(s_CTmess                    ,'A'   ,s_CTmessa                   ,pr_ct    ,hs_none);
    CELD(s_CTmessa                   ,'G'   ,s_CTmessag                  ,pr_ct    ,hs_none);
    CELD(s_CTmessag                  ,'E'   ,s_CTmessage                 ,pr_ct    ,hs_none);
    CELD(s_CTmessage                 ,'/'   ,s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTM                       ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTM_                  ," \t;tnlr",s_CTM_                      ,pr_ct    ,hs_none);
    CELC(s_CTMll                     ,"tnlr",s_CTM_                      ,pr_ct    ,hs_none);
    CELC(s_CTMb                      ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMbo                     ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMbou                    ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMboun                   ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMbound                  ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMbounda                 ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMboundar                ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMboundary               ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTMboundary_              ,"tnlr",s_CTM                       ,pr_ct    ,hs_none);
    CELC(s_CTM                       ," \t;",s_CTM_                      ,pr_ct    ,hs_none);
    CELL(s_CTM                       ,'\n'  ,s_CTMl                      ,pr_ct    ,hs_none);
    CELL(s_CTM_                      ,'\n'  ,s_CTMl                      ,pr_ct    ,hs_none);
    CELC(s_CTMl                      ," \t" ,s_CTMll                     ,NULL     ,hs_none);
    CELC(s_CTMll                     ," \t" ,s_CTMll                     ,NULL     ,hs_none);
    CELD(s_CTM_                      ,'B'   ,s_CTMb                      ,pr_ct    ,hs_none);
    CELD(s_CTMll                     ,'B'   ,s_CTMb                      ,pr_ct    ,hs_none);
    CELD(s_CTMb                      ,'O'   ,s_CTMbo                     ,pr_ct    ,hs_none);
    CELD(s_CTMbo                     ,'U'   ,s_CTMbou                    ,pr_ct    ,hs_none);
    CELD(s_CTMbou                    ,'N'   ,s_CTMboun                   ,pr_ct    ,hs_none);
    CELD(s_CTMboun                   ,'D'   ,s_CTMbound                  ,pr_ct    ,hs_none);
    CELD(s_CTMbound                  ,'A'   ,s_CTMbounda                 ,pr_ct    ,hs_none);
    CELD(s_CTMbounda                 ,'R'   ,s_CTMboundar                ,pr_ct    ,hs_none);
    CELD(s_CTMboundar                ,'Y'   ,s_CTMboundary               ,pr_ct    ,hs_none);
    CELL(s_CTMboundary               ,'='   ,s_CTMboundary_              ,pr_ct    ,hs_none);
    CELC(s_CTMboundary_            ,"\"tnlr",s_CTMl                      ,pr_ctb   ,hs_none);

    for (j = s_init; j < s_xxxx; j++)
        if (STATE_NAME_LEN > 8 && j < 99999) sprintf(statenames[j], "*%d*", (int)j);
          else statenames[j][0] = '\0';
    STNM(s_init          ,"s_init");
    STNM(s_F             ,"s_F");
    STNM(s_Fr            ,"s_Fr");
    STNM(s_Fro           ,"s_Fro");
    STNM(s_From          ,"s_From");
    STNM(s_body          ,"s_body");
    STNM(s_bF            ,"s_bF");
    STNM(s_bFr           ,"s_bFr");
    STNM(s_bFro          ,"s_bFro");
    STNM(s_bFrom         ,"s_bFrom");
    STNM(s_hF            ,"s_hF");
    STNM(s_hFr           ,"s_hFr");
    STNM(s_hFro          ,"s_hFro");
    STNM(s_hFrom         ,"s_hFrom");
    STNM(s_hFrom_        ,"s_hFrom_");
    STNM(s_header        ,"s_header");
    STNM(s_headers       ,"s_headers");
    STNM(s_headere       ,"s_headere");
    STNM(s_body          ,"s_body");
    STNM(s_D             ,"s_D");
    STNM(s_Da            ,"s_Da");
    STNM(s_Dat           ,"s_Dat");
    STNM(s_Date          ,"s_Date");
    STNM(s_Date_         ,"s_Date_");
    STNM(s_S             ,"s_S");
    STNM(s_Su            ,"s_Su");
    STNM(s_Sub           ,"s_Sub");
    STNM(s_Subj          ,"s_Subj");
    STNM(s_Subje         ,"s_Subje");
    STNM(s_Subjec        ,"s_Subjec");
    STNM(s_Subject       ,"s_Subject");
    STNM(s_Subject_      ,"s_Subject_");
    STNM(s_M             ,"s_M");
    STNM(s_Me            ,"s_Me");
    STNM(s_Mes           ,"s_Mes");
    STNM(s_Mess          ,"s_Mess");
    STNM(s_Messa         ,"s_Messa");
    STNM(s_Messag        ,"s_Messag");
    STNM(s_Message       ,"s_Message");
    STNM(s_Message_      ,"s_Message_");
    STNM(s_Message_I     ,"s_Message_I");
    STNM(s_Message_Id    ,"s_Message_Id");
    STNM(s_Message_Id_   ,"s_Message_Id_");
    STNM(s_R             ,"s_R");
    STNM(s_Re            ,"s_Re");
    STNM(s_Rec           ,"s_Rec");
    STNM(s_Rece          ,"s_Rece");
    STNM(s_Recei         ,"s_Recei");
    STNM(s_Receiv        ,"s_Receiv");
    STNM(s_Receive       ,"s_Receive");
    STNM(s_Received      ,"s_Received");
    STNM(s_Received_     ,"s_Received_");
    STNM(s_Rep           ,"s_Rep");
    STNM(s_Repl          ,"s_Repl");
    STNM(s_Reply         ,"s_Reply");
    STNM(s_Reply_        ,"s_Reply_");
    STNM(s_Reply_T       ,"s_Reply_T");
    STNM(s_Reply_To      ,"s_Reply_To");
    STNM(s_Reply_To_     ,"s_Reply_To_");
    STNM(s_Ref           ,"s_Ref");
    STNM(s_Refe          ,"s_Refe");
    STNM(s_Refer         ,"s_Refer");
    STNM(s_Refere        ,"s_Refere");
    STNM(s_Referen       ,"s_Referen");
    STNM(s_Referenc      ,"s_Referenc");
    STNM(s_Reference     ,"s_Reference");
    STNM(s_References    ,"s_References");
    STNM(s_References_   ,"s_References_");
    STNM(s_I             ,"s_I");
    STNM(s_In            ,"s_In");
    STNM(s_In_           ,"s_In_");
    STNM(s_In_R          ,"s_In_R");
    STNM(s_In_Re         ,"s_In_Re");
    STNM(s_In_Rep        ,"s_In_Rep");
    STNM(s_In_Repl       ,"s_In_Repl");
    STNM(s_In_Reply      ,"s_In_Reply");
    STNM(s_In_Reply_     ,"s_In_Reply_");
    STNM(s_In_Reply_T    ,"s_In_Reply_T");
    STNM(s_In_Reply_To   ,"s_In_Reply_To");
    STNM(s_In_Reply_To_  ,"s_In_Reply_To_");
    STNM(s_C                          ,"s_C");
    STNM(s_Co                         ,"s_Co");
    STNM(s_Con                        ,"s_Con");
    STNM(s_Cont                       ,"s_Cont");
    STNM(s_Conte                      ,"s_Conte");
    STNM(s_Conten                     ,"s_Conten");
    STNM(s_Content                    ,"s_Content");
    STNM(s_Content_                   ,"s_Content_");
    STNM(s_Content_T                  ,"s_Content_T");
    STNM(s_Content_Ty                 ,"s_Content_Ty");
    STNM(s_Content_Typ                ,"s_Content_Typ");
    STNM(s_Content_Type               ,"s_Content_Type");
    STNM(s_Content_Type_              ,"s_Content_Type_");
    STNM(s_CT                         ,"s_CT");
    STNM(s_CTm                        ,"s_CTm");
    STNM(s_CTmu                       ,"s_CTmu");
    STNM(s_CTmul                      ,"s_CTmul");
    STNM(s_CTmult                     ,"s_CTmult");
    STNM(s_CTmulti                    ,"s_CTmulti");
    STNM(s_CTmultip                   ,"s_CTmultip");
    STNM(s_CTmultipa                  ,"s_CTmultipa");
    STNM(s_CTmultipar                 ,"s_CTmultipar");
    STNM(s_CTmultipart                ,"s_CTmultipart");
    STNM(s_CTme                       ,"s_CTme");
    STNM(s_CTmes                      ,"s_CTmes");
    STNM(s_CTmess                     ,"s_CTmess");
    STNM(s_CTmessa                    ,"s_CTmessa");
    STNM(s_CTmessag                   ,"s_CTmessag");
    STNM(s_CTmessage                  ,"s_CTmessage");
    STNM(s_CTM                        ,"s_CTM");
    STNM(s_CTM_                       ,"s_CTM_");
    STNM(s_CTMl                       ,"s_CTMl");
    STNM(s_CTMll                      ,"s_CTMll");
    STNM(s_CTMb                       ,"s_CTMb");
    STNM(s_CTMbo                      ,"s_CTMbo");
    STNM(s_CTMbou                     ,"s_CTMbou");
    STNM(s_CTMboun                    ,"s_CTMboun");
    STNM(s_CTMbound                   ,"s_CTMbound");
    STNM(s_CTMbounda                  ,"s_CTMbounda");
    STNM(s_CTMboundar                 ,"s_CTMboundar");
    STNM(s_CTMboundary                ,"s_CTMboundary");
    STNM(s_CTMboundary_               ,"s_CTMboundary_");
    STNM(s_CTMB                       ,"s_CTMB");
    STNM(s_Content_Tr                 ,"s_Content_Tr");
    STNM(s_Content_Tra                ,"s_Content_Tra");
    STNM(s_Content_Tran               ,"s_Content_Tran");
    STNM(s_Content_Trans              ,"s_Content_Trans");
    STNM(s_Content_Transf             ,"s_Content_Transf");
    STNM(s_Content_Transfe            ,"s_Content_Transfe");
    STNM(s_Content_Transfer           ,"s_Content_Transfer");
    STNM(s_Content_Transfer_          ,"s_Content_Transfer_");
    STNM(s_Content_Transfer_E         ,"s_Content_Transfer_E");
    STNM(s_Content_Transfer_En        ,"s_Content_Transfer_En");
    STNM(s_Content_Transfer_Enc       ,"s_Content_Transfer_Enc");
    STNM(s_Content_Transfer_Enco      ,"s_Content_Transfer_Enco");
    STNM(s_Content_Transfer_Encod     ,"s_Content_Transfer_Encod");
    STNM(s_Content_Transfer_Encodi    ,"s_Content_Transfer_Encodi");
    STNM(s_Content_Transfer_Encodin   ,"s_Content_Transfer_Encodin");
    STNM(s_Content_Transfer_Encoding  ,"s_Content_Transfer_Encoding");
    STNM(s_Content_Transfer_Encoding_ ,"s_Content_Transfer_Encoding_");
    STNM(s_end                        ,"s_end");
    if (v_flag > 2) automata_print();
};

enum op {op_none, op_create, op_update, op_modify, op_add} op_do;
enum mailbox {mb_none, mb_file, mb_pipe} mb;
char *mailbox;

void parce()
/*****************************************************
 *
 * This is simpliest automata with the only expansion:
 * hashtbl[][], hashed and whashed - because of lack
 * of full control table of states under my eyes.
 *
 *****************************************************/
{   int c, p;

    do_ = NULL;
    workp = 0;
    ready_to_write = 0;
    state = s_init;
    hashed = 0;
    whashed = 0;
    while (1)
    {   c = getnext();
    if (v_flag > 1) fprintf(stderr, "char= %s, hs= %u,", cpr[c + 1], (unsigned)(hashtbl[state][c + 1]));
        switch (hashtbl[state][c + 1])
        {case hs_none : if (hashed) goto hs_oned;
         case hs_woff : if (hashed) {whashed++; break;};
         case hs_offed: hashed = 0; whashed = 0; break;
         case hs_won: if (!hashed) {whashed++;  break;};
         case hs_oned:
         hs_oned:
            hashed = 1;
            whashed++;
            p = (delayp - whashed) % MAX_DELAY;
            if (p < 0) p += MAX_DELAY;
            while (whashed)
            {   do_hash(&db->entry.mail_hash, delay[p++]);
                p = p % MAX_DELAY;
                whashed--;
            };
            break;
        };
    if (v_flag > 1) fprintf(stderr, "(%d.%d) pr = %08X,", hashed, whashed, (unsigned)(promata[state][c + 1]));
        if (promata[state][c + 1]) (promata[state][c + 1])(c);
        state = automata[state][c + 1];
    if (v_flag > 1) fprintf(stderr, " (%03u)state = %s\n", (unsigned)state, statenames[state]);
        if (state == s_end) break;
}   };

int can_chain(unsigned c, unsigned i)
{   if (c == 0 || i == 0) return(1);
    if (c > i) return((c - i) <= SHRT_MAX);
      else  return((i - c) <= SHRT_MAX);
};

void usage(int exitcode, char *errtext)
{   fprintf( stderr
           , "messarge "VERS" @BABOLO http://www.links.ru/soft/messarge/\n"
             "%s -{c|m|u|a} <options> <file IDX> <old file IDX (if -m)>\n"
             "    c - create IDX\n"
             "    m - change mailbox for the same IDX\n"
             " options for -{c|m}:\n"
             "        -f<mailbox> - mailbox is file <mailbox> - use full path or read man\n"
             "        -p<mailbox> - mailbox is pipe <mailbox> - can't be used with -a\n"
             "        -L<number of lists> - 0 to %u\n"
             "        -z<string's space>\n"
             "        -N<N> message number shift, N >= 0\n"
             "        -u - update IDX every mesarc call if need - can't be used with -p\n"
             "        -n - do not update IDX at mesarc call\n"
             "    u - update IDX\n"
             "    a - add mail from stdin - can't be used with -p\n"
             " options for -{u|a}:\n"
             "        -m - recreate all links in IDX\n"
             " common options:\n"
             "        -v - verbose (debug)\n"
             "        -l<list number> - can be multiple used\n"
             " <file IDX> must be a file, not a pipe\n%s\n"
           , myname, (unsigned)(MAX_L_NUMBER), errtext ? errtext : "");
     exit(exitcode);
};

int main(int argc, char **argv)
{   int i, j, c, last, try, tri;
    struct stat sb;
    unsigned char NLists = 0, LList = 0;
    unsigned var_size = DB_VAR_SIZE;
    int var_size_defined = 0, LLists_defined = 0, ListM_defined = 0;
    int u_flag = 0, n_flag = 0;
    unsigned N_start = 0;
    MASK_T u;
#ifdef DEBUG
# if DEBUG > 1
    char argv0[] = "mesdbc";
    char argv1[] = "-umvv";
    char argv2[] = "-l1";
    char argv3[] = "zm.db";
    char *arg[] = {argv0, argv1, argv2, argv3, NULL};
    argv = arg;
    argc = 4;
# endif
#endif

    myname = argv[0];
    op_do = op_none;
    mb = mb_none;
    mailbox = NULL;
    v_flag = m_flag = 0;
    opterr = 0;
    ListM = 0;
    while((c = getopt(argc, argv, "vcmuanf:p:z:L:l:N:?")) !=  -1)
    {   switch (c)
        {case 'v': v_flag++;                                break;
         case 'c': op_do = op_create;                       break;
         case 'm': if (op_do == op_none) op_do = op_modify;
                     else m_flag++;                         break;
         case 'u': if (op_do == op_none) op_do = op_update;
                     else u_flag++;                         break;
         case 'a': op_do = op_add;                          break;
         case 'n': n_flag++;                                break;
         case 'f': mb = mb_file; mailbox = optarg;          break;
         case 'p': mb = mb_pipe; mailbox = optarg;          break;
         case 'z': var_size = (int)strtol(optarg, NULL, 0); var_size_defined = 1; break;
         case 'L':
            NLists = (int)strtol(optarg, NULL, 0);
            if (NLists > MAX_L_NUMBER) usage(EX_USAGE, "List quontity is too high");
            LList = (NLists + 7) / 8;
            LLists_defined = 1;
            break;
         case 'l':
         {  int i = (int)strtol(optarg, NULL, 0);
            if (i > MAX_L_NUMBER) usage(EX_USAGE, "List number is too high");
            if (i == 0) ListM = 0;
            else
            {   for (u = 1; i > 1; i--) u *= 2;
                ListM |= u;
            };
            ListM_defined = 1;
            break;
         };
         case 'N':
            N_start = strtol(optarg, NULL, 0);
            break;
         default: usage(EX_USAGE, "No such flag");
    }   };
    argc -= optind;
    argv += optind;
    if (mb == mb_pipe && op_do == op_add) usage(EX_USAGE, "Add impossible for pipe");
    if (mb == mb_pipe && u_flag) usage(EX_USAGE, "Update impossible for pipe");
    if (mb == mb_pipe) n_flag = 1;
    if (op_do == op_none) usage(EX_USAGE, "What to do?");
    if (argc < 1) usage(EX_USAGE, "What is index name?");
    if (!strcmp(argv[0], "-")) usage(EX_USAGE, "Index must be file, not pipe");
    filemail = -1;
    filebdes = -1;
    mail_f_name[0] = '\0';
    db = calloc(1, sizeof(struct db));
    switch (op_do)
    {case op_create:
        {   if (argc != 1)                                                       usage(EX_USAGE, "-c have 1 parameter");
            if (!mailbox)                                                        usage(EX_USAGE, "-c needs in -f");
            if (mb != mb_none && strlen(mailbox) > DB_PATH_SIZE)
            {   fprintf(stderr, "%s: very long or absent mailbox name: %s\n", myname, mailbox);
                                                                                 exit(EX_USAGE);
            };
            if (mb == mb_file && mailbox && mailbox[0] != '/')
            {   char *c;
                (void)strncpy(mail_f_name, argv[0], WORK_SIZE - 1);
                c = rindex(mail_f_name, '/');
                if (c)
                {   *(++c) = '\0';
                    (void)strncat(mail_f_name, mailbox, WORK_SIZE - strlen(mail_f_name) - 1);
                }else (void)strncpy(mail_f_name, mailbox, WORK_SIZE - 1);
            }else (void)strncpy(mail_f_name, mailbox, WORK_SIZE - 1);
            mail_f_name[WORK_SIZE - 1] = '\0';
            if (var_size < 4)
            {   fprintf(stderr, "%s: -z too low: %u\n", myname, var_size);       exit(EX_USAGE);
            };
            if ((filebdes = open(argv[0], O_CREAT | O_TRUNC | O_RDWR, 0666)) < 0)perr(EX_CANTCREAT, argv[0]);
            if (flock(filebdes, LOCK_EX))                                        perr(EX_CANTCREAT, argv[0]);
            if ((DB_F = fdopen(filebdes, "w")) == NULL)                          perr(EX_CANTCREAT, argv[0]);
            db->header.magic = MAGIK_VV;
            db->header.var_size = var_size;
            db->header.N_start = N_start;
            if (u_flag) db->header.flags |= MAKE_ON_WAKEUP;
            strcpy(db->header.path, mailbox);
            db->header.len =  ( (void*)index(db->header.path, '\0')
                              - (void*)&db->header
                              + DB_BLOCK_SIZE
                              - 1
                              )
                            / DB_BLOCK_SIZE;
            db->header.NLists = NLists;
            db->header.LList = LList;
            if (1 != fwrite(&db->header, (db->header.len) * DB_BLOCK_SIZE, 1, DB_F))
                                                                                 perr(EX_IOERR, NULL);
            if (stat(mail_f_name, &sb)) /* XXX modify for pipe */
            {   fclose(DB_F);                                                    exit(EX_OK);
        }   };
        position = 0;
        bemail = 1;
        break;
     case op_update:
     case op_add:
        {   if (argc != 1) usage(EX_USAGE, NULL);
            arcsize = open_db(argv[0], update_m);
            arcsize = arcsize / DB_BLOCK_SIZE - db->header.len;
            if (arcsize == 0) position = 0;
            else
            {   if (fseek(DB_F, -(long)DB_BLOCK_SIZE, SEEK_END))                 perr(EX_IOERR, argv[0]);
                if (1 != fread(&db->entry, DB_BLOCK_SIZE, 1, DB_F))
                {   if (ferror(DB_F))                                            perr(EX_IOERR, argv[0]);
                    fprintf(stderr, "%s: last entry in DB not readable(?)\n", myname);
                    exit(EX_DATAERR);
                };
                position = db->entry.offset + db->entry.bodyl;
            };
            bemail = arcsize + 1;
            if (fseek(DB_F, 0, SEEK_END))                                        perr(EX_IOERR, argv[0]);
            j = 0; for (i = 0; i < db->header.NLists; i++) j = j * 2 + 1;
            if (ListM & !j)
            {   fprintf(stderr, "Max list defined %u\n", (unsigned)(db->header.NLists));
                                                                                 exit(EX_USAGE);
        }   };
        if (!ListM_defined && db->header.NLists == 1) ListM = 1;
        if (op_do == op_add)
        {   char buf[BUFSIZ];
            size_t i;

            if (db->header.path[0] != '/')
            {   char *c;
                (void)strncpy(mail_f_name, argv[0], WORK_SIZE - 1);
                c = rindex(mail_f_name, '/');
                if (c)
                {   *(++c) = '\0';
                    (void)strncat(mail_f_name, db->header.path, WORK_SIZE - strlen(mail_f_name) - 1);
                }else (void)strncpy(mail_f_name, db->header.path, WORK_SIZE - 1);
            }else (void)strncpy(mail_f_name, db->header.path, WORK_SIZE - 1);
            mail_f_name[WORK_SIZE - 1] = '\0';
            if ((filemail = open(mail_f_name, O_CREAT | O_APPEND | O_RDWR)) < 0)
                                                                                 perr(EX_NOINPUT, db->header.path);
            if (flock(filemail, LOCK_EX))                                        perr(EX_NOINPUT, db->header.path);
            i = BUFSIZ;
            while (i == BUFSIZ)
            {   if ((i = read(0, buf, i)) < 0)                                   perr(EX_IOERR, db->header.path);
                if (write(filemail, buf, i) != i)                                perr(EX_IOERR, db->header.path);
        }   };
        break;
     case op_modify:
        {   unsigned offset, bodyl;

            offset = bodyl = 0;
            if (argc != 2)                                                      usage(EX_USAGE, NULL);
            if (mb != mb_none && strlen(mailbox) > DB_PATH_SIZE)
            {   fprintf(stderr, "%s: very long or absent mailbox name: %s\n", myname, mailbox);
                exit(EX_USAGE);
            };
            if (mb == mb_file && mailbox && mailbox[0] != '/')
            {   char *c;
                (void)strncpy(mail_f_name, argv[0], WORK_SIZE - 1);
                c = rindex(mail_f_name, '/');
                if (c)
                {   *(++c) = '\0';
                    (void)strncat(mail_f_name, mailbox, WORK_SIZE - strlen(mail_f_name) - 1);
                }else (void)strncpy(mail_f_name, mailbox, WORK_SIZE - 1);
            }else (void)strncpy(mail_f_name, mailbox, WORK_SIZE - 1);
            mail_f_name[WORK_SIZE - 1] = '\0';
            if (var_size < 4)
            {   fprintf(stderr, "%s: -z too low: %u\n", myname, var_size);       exit(EX_USAGE);
            };
            if ((newbdes = open(argv[0], O_CREAT | O_TRUNC | O_RDWR, 0666)) < 0) perr(EX_CANTCREAT, argv[0]);
            if (flock(newbdes, LOCK_EX))                                         perr(EX_CANTCREAT, argv[0]);
            if ((NEW_F = fdopen(newbdes, "w")) == NULL)                          perr(EX_CANTCREAT, argv[0]);
            arcsize = open_db(argv[1], old_m);
            arcsize = (arcsize / blocksize) - db->header.len;
            if (fseek(DB_F, db->header.len * blocksize, SEEK_SET))               perr(EX_IOERR, argv[1]);
            if (var_size_defined)
            {   var_size_defined = var_size - db->header.var_size;
                db->header.var_size = var_size;
            };
            db->header.N_start = N_start;
            if (u_flag) db->header.flags |= MAKE_ON_WAKEUP;
            if (n_flag) db->header.flags &= ~MAKE_ON_WAKEUP;
            if (mailbox)
            {   bzero(db->header.path, DB_PATH_SIZE);
                strcpy(db->header.path, mailbox);
            };
            db->header.len =  ( (void*)index(db->header.path, '\0')
                              - (void*)&db->header + DB_BLOCK_SIZE
                              )
                            / DB_BLOCK_SIZE;
            if (LLists_defined)
            {   LLists_defined = LList - db->header.LList;
                db->header.NLists = NLists;
                db->header.LList = LList;
            };
            if (1 != fwrite(&db->header, (db->header.len) * DB_BLOCK_SIZE, 1, NEW_F))
                                                                                 perr(EX_IOERR, NULL);
            bemail = 1;
            if (v_flag) fprintf( stderr
                               , "var_size change = %d, NLists change = %d\nfrom %u to %u\n"
                               , var_size_defined, LLists_defined, bemail, (unsigned)arcsize
                               );
            for (i = bemail; i <= arcsize; i++)
            {   if (1 != fread(&db->entry, blocksize, 1, DB_F))                  perr(EX_IOERR, NULL);
                switch(messarge_version) /* this is place for version converting code */
                {case MAGIK_00:
                    bcopy(((struct db_entry_00 *)(&db->entry))->var, db->entry.var, DB_VAR_MAX_SIZE);
                    db->entry.encapsulation = ((struct db_entry_00 *)(&db->entry))->encapsulation;
                    db->entry.charset       = ((struct db_entry_00 *)(&db->entry))->charset;
                    db->entry.th            = ((struct db_entry_00 *)(&db->entry))->th;
                    db->entry.right         = ((struct db_entry_00 *)(&db->entry))->right;
                    db->entry.next          = ((struct db_entry_00 *)(&db->entry))->next;
                    db->entry.prev          = ((struct db_entry_00 *)(&db->entry))->prev;
                    db->entry.lext          = ((struct db_entry_00 *)(&db->entry))->lext;
                    db->entry.plex          = ((struct db_entry_00 *)(&db->entry))->plex;
                    db->entry.stored_time   = ((struct db_entry_00 *)(&db->entry))->stored_time;
                    db->entry.mail_time     = ((struct db_entry_00 *)(&db->entry))->mail_time;
                    db->entry.boundl      = 0;
                    db->entry.bound       = 0;
                 case MAGIK_VV:
                };
                if (LLists_defined)
                {   if (var_size_defined < LLists_defined)
                    {   bcopy( &db->entry.var[db->header.LList - LLists_defined]
                             , &db->entry.var[db->header.LList]
                             , db->header.var_size - db->header.LList
                             );
                        db->entry.var[db->header.var_size - 1] = '\0';
                    }else
                    {   bcopy( &db->entry.var[db->header.LList - LLists_defined]
                             , &db->entry.var[db->header.LList]
                             ,   db->header.var_size - var_size_defined
                               - db->header.LList + LLists_defined
                             );
                        bzero( &db->entry.var[db->header.var_size - var_size_defined + LLists_defined]
                             , var_size_defined - LLists_defined
                             );
                    };
                    if (LLists_defined > 0)
                        bzero(&db->entry.var[db->header.LList - LLists_defined], LLists_defined);
                }
                if (ListM_defined)
                {   for (j = 0; j < db->header.LList; j++)
                        if (ListM) db->entry.var[j] |= ListM >> (8 * j);
                          else db->entry.var[j] = 0;
                }
                if (offset != db->entry.offset || bodyl != db->entry.bodyl)
                    if (1 != fwrite(&db->entry, DB_BLOCK_SIZE, 1, NEW_F))        perr(EX_IOERR, NULL);
                offset = db->entry.offset; bodyl = db->entry.bodyl;
        }   };
        if (fclose(DB_F))                                                        perr(EX_IOERR, NULL);
        if (fclose(NEW_F))                                                       perr(EX_IOERR, NULL);
        exit(EX_OK);
     default:
        fprintf(stderr, "%s: Not yet\n", myname);
        exit(EX_OK);
    };
    if (filemail >= 0)
    {   if (flock(filemail, LOCK_SH))                                            perr(EX_NOINPUT, db->header.path);
    }else if (db->header.flags & PATH_IS_PIPE)
    {   int i, fd[2];
        if (pipe(fd))                                                            perr(EX_IOERR, NULL);
        if ((i = fork()) < 0)                                                    perr(EX_IOERR, NULL);
        if (!i)
        {   if (dup2(1, fd[1]))                                                  perr(EX_IOERR, NULL);
            execl("/bin/sh", "/bin/sh", "-c", db->header.path);                  perr(EX_IOERR, NULL);
        };
        filemail = fd[0];
    }else
    {   if (db->header.path[0] != '/')
        {   unsigned char *c;
            (void)strncpy(mail_f_name, argv[0], WORK_SIZE - 1);
            c = rindex(mail_f_name, '/');
            if (c)
            {   *(++c) = '\0';
                (void)strncat(mail_f_name, db->header.path, WORK_SIZE - strlen(mail_f_name) - 1);
            }else (void)strncpy(mail_f_name, db->header.path, WORK_SIZE - 1);
        }else (void)strncpy(mail_f_name, db->header.path, WORK_SIZE - 1);
        mail_f_name[WORK_SIZE - 1] = '\0';
        if ((filemail = open(mail_f_name, O_RDONLY)) < 0)                        perr(EX_NOINPUT, db->header.path);
        if (flock(filemail, LOCK_SH))                                            perr(EX_NOINPUT, db->header.path);
    };
    if ((MAIL_F = fdopen(filemail, "r")) == NULL)                                perr(EX_NOINPUT, db->header.path);
    /* XXX pipe */
    if (fseek(MAIL_F, position, SEEK_SET))                                       perr(EX_IOERR, db->header.path);
    automata_init();
    exr( &date0_ex
       , "^[A-Za-z--]*[, \t]*([0-9]{1,2})[, \t]+([A-Za-z--]+)[, \t]+([0-9]{2,4})[, \t]+"
         "([0-9]{1,2}):([0-9]{1,2})(:([0-9]{1,2}))?([, \t]+([+-]?([0-9]{2})([0-9]{2})([^0-9]|$)))?"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &date1_ex
       , "^[A-Za-z--]*[, \t]*([A-Za-z--]+)[, \t]+([0-9]{1,2})[, \t]+([0-9]{2,4})[, \t]+"
         "([0-9]{1,2}):([0-9]{1,2})(:([0-9]{1,2}))?([, \t]+([+-]?([0-9]{2})([0-9]{2})([^0-9]|$)))?"
       , REG_EXTENDED | REG_ICASE
       );
/*  exr( &date2_ex
 *     , "^[A-Za-z--]*[, \t]*([0-9]{1,2})/([0-9]{1,2})/([0-9]{2,4})[, \t]+"
 *       "([0-9]{1,2}):([0-9]{1,2})(:([0-9]{1,2}))?[, \t]*(AM|PM)?"
 *       "[, \t]*(([+-]?([0-9]{2})([0-9]{2})([^0-9]|$)))?"
 *     , REG_EXTENDED | REG_ICASE
 *     );
 */
    exr( &subj0_ex
       , "([ \t]*\\([ \t]*fwd[ \t]*\\))*[ \t]*$"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &subj1_ex, RE_EXCL_RE, REG_EXTENDED | REG_ICASE);
    exr( &from0_ex
       , "[, \t]*<(([-a-zA-Z0-9]*!)*[-./;=?_+*&%$#--a-zA-Z0-9]+(%[-.a-zA-Z0-9]*)?"
         "(@[-.a-zA-Z0-9]+|\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\])?)>[, \t]*$"
       , REG_EXTENDED
       );
    exr( &from1_ex
       , "^(([-a-zA-Z0-9]*!)*[-./;=?_+*&%$#--a-zA-Z0-9]+(%[-.a-zA-Z0-9]*)?"
         "(@[-.a-zA-Z0-9]+|\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\])?)[, \t]*"
         "\\((.+)\\)[, \t]*$"
       , REG_EXTENDED
       );
    exr( &from2_ex
       , "^(([-a-zA-Z0-9]*!)*[-./;=?_+*&%$#--a-zA-Z0-9]+(%[-.a-zA-Z0-9]*)?"
         "(@([-.a-zA-Z0-9]+|\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\]))?)[, \t]*$"
       , REG_EXTENDED
       );
    exr( &from3_ex
       , "[, \t]*<(([-a-zA-Z0-9]*!)*[-./;=?_+*&%$#--a-zA-Z0-9]+(%[-.a-zA-Z0-9]*)?"
         "@([-.a-zA-Z0-9]+|\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\]))>[, \t]*"
       , REG_EXTENDED
       );
    exr( &from4_ex
       , "[, \t]*(([-a-zA-Z0-9]*!)*[-./;=?_+*&%$#--a-zA-Z0-9]+(%[-.a-zA-Z0-9]*)?"
         "@([-.a-zA-Z0-9]+|\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\]))[, \t]*"
       , REG_EXTENDED
       );
    exr( &id_ex
       , "<([-_.+=%\\$a-zA-Z0-9]+@"
         "([-_.a-zA-Z0-9]+|\\[[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\.[0-9]{1,3}\\]))>"     //&#; 
       , REG_EXTENDED
       );
    exr( &codk_ex
       , "=\\?KOI8[-_.A-Z0-9]*\\?([BQ])\\?"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &coda_ex
       , "=\\?X-CP866\\?([BQ])\\?"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &codw_ex
       , "=\\?WINDOWS-1251\\?([BQ])\\?"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &codi_ex
       , "=\\?ISO-8859-5\\?([BQ])\\?"
       , REG_EXTENDED | REG_ICASE
       );
    exr( &cte0_ex, "^7BIT$"            , REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &cte1_ex, "^8BIT$"            , REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &cte2_ex, "^binary$"          , REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &cte3_ex, "^quoted-printable$", REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &cte4_ex, "^base64$"          , REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &cte5_ex, "^x-uuencode$"      , REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &cte6_ex, "^uuencode$"        , REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &cod_ex, "^text(/[-.A-Z0-9]*)?[ \t]*", REG_EXTENDED | REG_ICASE | REG_NOSUB);
    exr( &ctyk_ex
       , "^TEXT/[-A-Z0-9]+[ \t]*;.*CHARSET[ \t]*=[ \t]*\"?KOI8-R"
       , REG_EXTENDED | REG_ICASE | REG_NOSUB
       );
    exr( &ctya_ex
       , "^TEXT/[-.A-Z0-9]+[ \t]*;.*CHARSET[ \t]*=[ \t]*\"?X-CP866"
       , REG_EXTENDED | REG_ICASE | REG_NOSUB
       );
    exr( &ctyw_ex
       , "^TEXT/[-.A-Z0-9]+[ \t]*;.*CHARSET[ \t]*=[ \t]*\"?WINDOWS-1251"
       , REG_EXTENDED | REG_ICASE | REG_NOSUB
       );
    exr( &ctyi_ex
       , "^TEXT/[-.A-Z0-9]+[ \t]*;.*CHARSET[ \t]*=[ \t]*\"?ISO-8859-5"
       , REG_EXTENDED | REG_ICASE | REG_NOSUB
       );
    exr( &ctyh_ex
       , "^TEXT/HTML"
       , REG_EXTENDED | REG_ICASE | REG_NOSUB
       );
/*  exr( &cty1_ex
 *     , "^MULTIPART/[-.A-Z0-9]+[ \t]*;.*BOUNDARY=([-!#$%&'*+.^_`\\{\\}\\|~--A-Z0-9])"
 *     , REG_EXTENDED | REG_ICASE
 *     );
 */
    parce();
    if (fclose(MAIL_F))                                                          perr(EX_IOERR, db->header.path);
    if (fflush(DB_F))                                                            perr(EX_IOERR, db->header.path);
    if (fstat(filebdes, &sb))                                                    perr(EX_IOERR, NULL);
    maxmail = sb.st_size / DB_BLOCK_SIZE - db->header.len;
    if (m_flag || bemail <= maxmail)
    {   if ((void *)( entries
                   = (struct db_entry*)mmap( NULL
                                           , (maxmail + db->header.len) * DB_BLOCK_SIZE
                                           , PROT_READ | PROT_WRITE, MAP_SHARED, filebdes, 0
                                           )
                   ) == MAP_FAILED
          )                                                                      perr(EX_NOINPUT, NULL);
        try = 0;
        tri = maxmail;
try:    while (++try < 2)
        {   if (v_flag) fprintf( stderr, "Try %d\n", try);
            if (m_flag || tri <= 0)
            {   for (i = 1; i <= maxmail; i++)
                {   ENTRY(i)->next = 0;
        ;           ENTRY(i)->prev = 0;
        ;           ENTRY(i)->plex = 0;
        ;           ENTRY(i)->lext = 0;
        ;           if ((m_flag > 1) || (ENTRY(i)->th != th_purge)) ENTRY(i)->th = 0;
        ;           ENTRY(i)->right = 0;
        ;       };
        ;       bemail = 1;
        ;   };
        ;   if (v_flag) fprintf( stderr, "Rebuild from %u to %u try %d\n"
                               , db->header.N_start + bemail
                               , db->header.N_start + maxmail
                               , try
                               );
        ;   last = bemail - 1 > 0 ? bemail - 1 : 0;
        ;   tri = maxmail;
        ;   while (last && ENTRY(last)->next)
            {   last += ENTRY(last)->next;
        ;       if (tri-- < 0) goto try;
        ;   };
        ;   for (i = bemail; i <= maxmail; i++)
            {   int level = 0;
        ;       c = 0;
        ;       if ((ENTRY(i)->th != th_purge) && ENTRY(i)->mail_hash)
                {   th_state = th_root;
        ;           if (ListM && ENTRY(i)->id_hash)
       /*             ListM
        */
                        for (j = i - 1; j > 0; j--)
                            if ((ENTRY(j)->th != th_purge) && (ENTRY(i)->id_hash == ENTRY(j)->id_hash))
                            {   c = j; th_state = th_hidden;
        ;                       if (v_flag)
                                    fprintf( stderr, "found id %u for id %u\n"
                                           , (unsigned)(db->header.N_start + j)
                                           , (unsigned)(db->header.N_start + i)
                                           );
        ;                       break;
        ;                   };
                    if (!c && ENTRY(i)->repl_hash)
                        for (j = i - 1; j > 0; j--)
                            if ((ENTRY(j)->th != th_purge) && (ENTRY(i)->repl_hash == ENTRY(j)->id_hash))
                            {   c = j; th_state = th_child;
        ;                       if (v_flag)
                                    fprintf( stderr, "found id %u for repl %u\n"
                                           , (unsigned)(db->header.N_start + j)
                                           , (unsigned)(db->header.N_start + i)
                                           );
        ;                       break;
        ;                   };
        ;           if (!c && ENTRY(i)->repl_hash)
                        for (j = i - 1; j > 0; j--)
                            if ((ENTRY(j)->th != th_purge) && (ENTRY(i)->repl_hash == ENTRY(j)->repl_hash))
                            {   c = j; th_state = th_brother;
        ;                       if (v_flag)
                                    fprintf( stderr, "found repl %u for repl %u\n"
                                           , (unsigned)(db->header.N_start + j)
                                           , (unsigned)(db->header.N_start + i)
                                           );
        ;                       break;
        ;                   };
/*      ;           if (!c && ENTRY(i)->id_hash)
 *                      for (j = i - 1; j > 0; j--)
 *                          if ((ENTRY(j)->th != th_purge) && (ENTRY(i)->id_hash == ENTRY(j)->repl_hash))
 *                          {   c = j; th_state = th_parent;
 *      ;                       if (v_flag)
                                    fprintf( stderr, "found repl %u for id %u\n"
                                           , (unsigned)(db->header.N_start + j)
                                           , (unsigned)(db->header.N_start + i)
                                           );
 *      ;                       break;
 *      ;                   };
 */
        ;           if (!c && ENTRY(i)->subj_hash)
                        for (j = i - 1; j > 0; j--)
                            if ((ENTRY(j)->th != th_purge) && (ENTRY(i)->subj_hash == ENTRY(j)->subj_hash))
                            {   c = j; th_state = th_cousen;
        ;                       if (v_flag)
                                    fprintf( stderr, "found subj %u for subj %u\n"
                                           , (unsigned)(db->header.N_start + j)
                                           , (unsigned)(db->header.N_start + i)
                                           );
        ;                       break;
        ;                   };
        ;       }else th_state = th_purge;
        ;       tri = maxmail;
        ;       while (c && ENTRY(c)->th == th_hidden)
                {   if (v_flag) fprintf( stderr, "shift for hidden %u to %u\n"
                                       , (unsigned)(db->header.N_start + c)
                                       , (unsigned)(db->header.N_start + c + ENTRY(c)->next)
                                       );
        ;           c += ENTRY(c)->next;
        ;           if (tri-- < 0) goto try;
                };      

        ;       ENTRY(i)->th = th_state;
        ;       switch (th_state)
                {case th_root:
        ;           tri = maxmail;
        ;           while (last && ENTRY(last)->next)
                    {   last += ENTRY(last)->next;
        ;               if (tri-- < 0) goto try;
                    };
        ;           {   if (v_flag)
                            fprintf( stderr
                                   , "%u.next %u for root\n"
                                   , (unsigned)(db->header.N_start + last)
                                   , (unsigned)(db->header.N_start + i)
                                   );
        ;               ENTRY(i)->next = 0;
        ;               ENTRY(i)->right = 0;
        ;               if (last)
                        {   ENTRY(i)->prev = last - i;
        ;                   ENTRY(last)->next = i - last;
        ;               };
        ;               last = i;
        ;           };
        ;           break;
        ;        case th_cousen:
        ;           tri = maxmail;
        ;           while (  ENTRY(c)->next
                          && ENTRY(c + ENTRY(c)->next)->th != th_root
                          )
                    {   if (v_flag)
                            fprintf( stderr
                                   , "follow %u.next for cousen: %u\n"
                                   , (unsigned)(db->header.N_start + c)
                                   , (unsigned)(db->header.N_start + c + ENTRY(c)->next)
                                   );
        ;               c += ENTRY(c)->next;
        ;               level += ENTRY(c)->right;
        ;               if (tri-- < 0) goto try;
        ;           };
        ;           j = ENTRY(c)->next ? c + ENTRY(c)->next : 0;
        ;           if (can_chain(c, i) && can_chain(i, j))
                    {   if (v_flag)
                            fprintf( stderr
                                   , "%u.next %u prev.%u for cousen\n"
                                   , (unsigned)(db->header.N_start + c)
                                   , (unsigned)(db->header.N_start + i)
                                   , (unsigned)(db->header.N_start + j)
                                   );
        ;               if (j) ENTRY(j)->prev = i - j;
        ;               ENTRY(i)->next = j ? j - i : 0;
        ;               ENTRY(i)->right = 0;
        ;               ENTRY(i)->prev = c - i;
        ;               ENTRY(c)->next = i - c;
        ;           };
        ;           break;
        ;        case th_brother:
        ;           tri = maxmail;
        ;           while (  ENTRY(c)->next
                          && ENTRY(c + ENTRY(c)->next)->th != th_root
                          && ENTRY(c + ENTRY(c)->next)->th != th_cousen
                          && level + ENTRY(c + ENTRY(c)->next)->right >= 0
                          )
                    {   if (v_flag)
                            fprintf( stderr
                                   , "follow %u.next for brother: %u\n"
                                   , (unsigned)(db->header.N_start + c)
                                   , (unsigned)(db->header.N_start + c + ENTRY(c)->next)
                                   );
        ;               c += ENTRY(c)->next;
        ;               level += ENTRY(c)->right;
        ;               if (tri-- < 0) goto try;
        ;           };
        ;           j = ENTRY(c)->next ? c + ENTRY(c)->next : 0;
        ;           if (can_chain(c, i) && can_chain(i, j))
                    {   if (v_flag)
                            fprintf( stderr
                                   , "%u.next %u prev.%u for brother\n"
                                   , (unsigned)(db->header.N_start + c)
                                   , (unsigned)(db->header.N_start + i)
                                   , (unsigned)(db->header.N_start + j)
                                   );
        ;               if (j)
                        {   ENTRY(j)->prev = i - j;
        ;                   ENTRY(j)->right += level;
        ;               };
        ;               ENTRY(i)->next = j ? j - i : 0;
        ;               ENTRY(i)->right = -level;
        ;               ENTRY(i)->prev = c - i;
        ;               ENTRY(c)->next = i - c;
        ;           };
        ;           break;
        ;        case th_child:
        ;           tri = maxmail;
        ;           while (  ENTRY(c)->next
                          && ENTRY(c + ENTRY(c)->next)->th != th_root
                          && ENTRY(c + ENTRY(c)->next)->th != th_cousen
                          && level + ENTRY(c + ENTRY(c)->next)->right > 0
                          )
                    {   if (v_flag)
                            fprintf( stderr
                                   , "follow %u.next for child: %u\n"
                                   , (unsigned)(db->header.N_start + c)
                                   , (unsigned)(db->header.N_start + c + ENTRY(c)->next)
                                   );
        ;               c += ENTRY(c)->next;
        ;               level += ENTRY(c)->right;
        ;               if (tri-- < 0) goto try;
        ;           };
        ;           j = ENTRY(c)->next ? c + ENTRY(c)->next : 0;
        ;           if (can_chain(c, i) && can_chain(i, j))
                    {   if (v_flag)
                            fprintf( stderr
                                   , "%u.next %u prev.%u for child\n"
                                   , (unsigned)(db->header.N_start + c)
                                   , (unsigned)(db->header.N_start + i)
                                   , (unsigned)(db->header.N_start + j)
                                   );
        ;               if (j)
                        {   ENTRY(j)->prev = i - j;
        ;                   ENTRY(j)->right += level - 1;
        ;                   if (ENTRY(j)->repl_hash && ENTRY(j)->repl_hash == ENTRY(i)->id_hash)
                            {   if (v_flag)
                                    fprintf( stderr
                                           , "%u is child %u\n"
                                           , (unsigned)(db->header.N_start + j)
                                           , (unsigned)(db->header.N_start + i)
                                           );
        ;                       ENTRY(j)->th = th_child;
        ;                       ENTRY(j)->right = 1;
        ;               }   };
        ;               ENTRY(i)->next = j ? j - i : 0;
        ;               ENTRY(i)->right = -level + 1;
        ;               ENTRY(i)->prev = c - i;
        ;               ENTRY(c)->next = i - c;
        ;           };
        ;           break;
        ;        case th_hidden:
        ;           if (can_chain(c, i))
                    {   if (v_flag)
                            fprintf( stderr
                                   , "%u <-> (%u) for hidden\n"
                                   , (unsigned)(db->header.N_start + c)
                                   , (unsigned)(db->header.N_start + i)
                                   );
       /*  prev  next    
        */
        ;               ENTRY(i)->right = 0;
        ;               ENTRY(i)->prev = c - i;
        ;               ENTRY(i)->next = c - i;
        ;           };
       /*      , ..      ,
        *     ,      , 
        *  ,  
        */
        ;           for (j= 0; j < db->header.LList; j++) 
                    {   ENTRY(i)->var[j] = 0;
        ;               ENTRY(c)->var[j] |= ListM >> (8 * j);
        ;           };
        ;           break;
        ;        case th_purge:
        ;           if (v_flag) fprintf(stderr, "%u purge\n", (unsigned)(db->header.N_start + i));
        ;               ENTRY(i)->right = 0;
        ;               ENTRY(i)->prev = 0;
        ;               ENTRY(i)->next = 0;
        ;           break;
        ;        default:
        ;           fprintf(stderr, "%s: Internal error - th_state = %u\n", myname, (unsigned)th_state);
        ;           exit(EX_SOFTWARE);
        ;   }   };
        ;   if (munmap((void*)entries, (maxmail + db->header.len) * DB_BLOCK_SIZE))
                                                                                 perr(EX_IOERR, NULL);
        ;   if (close(filebdes))                                                 perr(EX_IOERR, NULL);
        ;   exit(EX_OK);
        };
        if (close(filebdes))                                                     perr(EX_IOERR, NULL);
        fprintf(stderr, "%s: Try end - abort\n", myname);
        exit(EX_SOFTWARE);
    };
    if (close(filebdes))                                                         perr(EX_IOERR, NULL);
    exit(EX_OK);
}
