/*
 * @BABOLO (C)1999, 2000 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: mesraw.yy,v 1.4 2000/05/28 16:10:14 babolo Exp $
 *     $Name:  $
 */
%option noyywrap 8bit batch nodefault
%s INITIALS PURGE TRACK HEADR BODY BODYS

%{
#   include <unistd.h>
#   include <string.h>
#   include <sysexits.h>
#   define HL 255

    int bemail, domail;
    int v_flag, n_flag, q_flag;
    int header_print, body_print, scan_print, select_print;

    enum flag {from_h, subj_h, to_h, cc_h, bcc_h, date_h, repl_h, id_h, type_h, xxx_h};
    enum flag h;
    struct h_about
    {   char          flag;
        unsigned char track;
        char          header[32];
    }   h_about[xxx_h] =
    {{ 'f', 0, "From: "}
    ,{ 's', 0, "Subject: "}
    ,{ 't', 0, "To: "}
    ,{ 'c', 0, "Cc: "}
    ,{ 'b', 0, "Bcc: "}
    ,{ 'd', 0, "Date: "}
    ,{ 'r', 0, "In-Reply-To: "}
    ,{ 'i', 0, "Message-Id: "}
    ,{ 'y', 0, "Content-Type: "}
    };
%}
%%
%{
    void next_header(enum flag hdr)
    {   if (h_about[hdr].track)
        {   if (n_flag) fprintf(yyout, "%6d ", domail);
            fprintf(yyout, "%s", h_about[hdr].header);
            BEGIN(TRACK);
        }else
        {   if (header_print) ECHO;
            BEGIN(PURGE);
    }   };
%}
<INITIAL>"From "         {   domail++;
                             if (bemail == domail)
                             {   if (header_print) ECHO;
                                 BEGIN(PURGE);
                             }else BEGIN(INITIALS);
                         }
<INITIAL>\n
<INITIAL>[^\n]           BEGIN(INITIALS);
<INITIALS>[^\n]*\n       BEGIN(INITIAL);
<INITIALS>.

<PURGE>[^\n]*            if (header_print) ECHO;
<PURGE>\n[ \t]+
<PURGE>\n                if (header_print) ECHO; BEGIN(HEADR);

<TRACK>[^\n]*            ECHO;
<TRACK>\n[ \t]+
<TRACK>\n                ECHO; BEGIN(HEADR);

<HEADR>^[Ff][Rr][Oo][Mm]":"[ \t]*                                next_header(from_h);
<HEADR>^[Ss][Uu][Bb][Jj][Ee][Cc][Tt]":"[ \t]*                    next_header(subj_h);
<HEADR>^[Tt][Oo]":"[ \t]*                                        next_header(to_h);
<HEADR>^[Cc][Cc]":"[ \t]*                                        next_header(cc_h);
<HEADR>^[Bb][Cc][Cc]":"[ \t]*                                    next_header(bcc_h);
<HEADR>^[Dd][Aa][Tt][Ee]":"[ \t]*                                next_header(date_h);
<HEADR>^[Ii][Nn]"-"[Rr][Ee][Pp][Ll][Yy]"-"[Tt][Oo]":"[ \t]*      next_header(repl_h);
<HEADR>^[Mm][Ee][Ss][Ss][Aa][Gg][Ee]"-"[Ii][Dd]":"[ \t]*         next_header(id_h);
<HEADR>^[Cc][Oo][Nn][Tt][Ee][Nn][Tt]"-"[Tt][Yy][Pp][Ee]":"[ \t]* next_header(type_h);
<HEADR>[^\n]             if (header_print) ECHO; BEGIN(PURGE);
<HEADR>\n                if ((header_print || select_print) && body_print) ECHO; BEGIN(BODY);

<BODY>^"From "           {   domail++;
                             BEGIN(PURGE);
                             if (!scan_print) return(0);
                             else if (header_print) ECHO;
                         }
<BODY>\n                 if (body_print) ECHO;
<BODY>[^\n]              if (body_print) ECHO; BEGIN(BODYS);

<BODYS>[^\n]*\n          if (body_print) ECHO; BEGIN(BODY);
<BODYS>.                 if (body_print) ECHO;

%%

int main(int argc, char **argv)
{   int c;

    v_flag = n_flag = q_flag = 0;
    for (h = 0; h < xxx_h; h++) h_about[h].track = 0;
    opterr = 0;
    while((c = getopt(argc, argv, "vnqfstcbdriy?")) !=  -1)
    {   switch(c)
        {case 'v': v_flag = 1; break;
         case 'n': n_flag = 1; break;
         case 'q': q_flag = 1; break;
         default:
            for (h = 0; h < xxx_h; h++)
                if (h_about[h].flag == c)
                {   h_about[h].track++;
                    break;
                };
            if (h == xxx_h)
            {   fprintf( stderr
                       , "messarge "VERS" @BABOLO http://links.ru/soft/messarge/\n"
                         "%s -<options>\n"
                         "     -n -     (  1)\n"
                         "     -q -       -fstcbd,     \n"
                         "           ,     \n"
                       , argv[0]
                       );
                for (h = 0; h < xxx_h; h++)
                    fprintf( stderr, "     -%c -   %s\n"
                           , h_about[h].flag, h_about[h].header
                           );
                exit(EX_USAGE);
    }   }   };
    argc -= optind;
    argv += optind;

    if (argc == 0)
    {   scan_print = 1; bemail = 1;
    }else if (argc == 1)
    {   scan_print = 0; bemail = atoi(argv[0]);
    }else
    {   fprintf(stderr, "argc = %d\n", argc); exit(1);
    };
    select_print = 0;
    for (h = 0; h < xxx_h; h++)
        select_print |= h_about[h].track;
    header_print = !q_flag && !select_print;
    body_print = !q_flag || !select_print;
    domail = 0;
    if (v_flag)
    {   fprintf( stderr, "scan=%d, header=%d, body=%d, select=%d\n"
               , scan_print, header_print, body_print, select_print
               );
        for (h = 0; h < xxx_h; h++)
             fprintf(stderr, " -%c=%d,", h_about[h].flag, h_about[h].track);
        fprintf(stderr, "\n");
    };
    yylex();
    exit(0);
}


