/*
 * @BABOLO (C)1999, 2000 http://www.links.ru/~babolo/
 * Free to use, copy or modify while this message included in text
 * and my logo and URL saved in usage().
 * Warranty with special agreement only.
 * $Id: messarge.h,v 1.9 2000/05/28 16:10:14 babolo Exp $
 *     $Name:  $
 */
#include <sys/errno.h>
#include <sys/types.h>
#include <sys/wait.h>
#include <sys/stat.h>
#include <sys/file.h>
#include <sys/mman.h>
#include <sys/time.h>
#include <sysexits.h>
#include <string.h>
#include <unistd.h>
#include <stdlib.h>
#include <limits.h>
#include <fcntl.h>
#include <regex.h>
#include <stdio.h>
#include <time.h>

#ifndef STRTOQ
#   define STRTOQ strtoq
#endif
#ifndef P_MASK
#   define P_MASK 017777  /* page size for mmap. be careful */
#endif

#define HDR_FLAG 000001
#define WWW_FLAG 000002
#define BIN_FLAG 000004

#define WORK_SIZE 1024
#define STATE_NAME_LEN 32
#define DB_VAR_MAX_SIZE 1024
#define DB_PATH_SIZE 1024
#define DB_VAR_SIZE 183
#define MAX_L_NUMBER 32
#define MASK_T unsigned            /* Depends on MAX_L_NUMBER */
#define DB_BLOCK_SIZE ((void*)db->entry.var - (void*)&db->entry + db->header.var_size)
#define RE_EXCL_RE "^((RE:|RE\\[[0-9]*\\]:|Subject:|[H][A]:|FW:|:|OTP:|:)[ \t]*)*"
#define RE_STRING "> "

#define ENTRY(a) ((struct db_entry*)\
                     (       ((void*)entries)\
                     +   (   (   (void*)db->entry.var\
                             -   (void*)&db->entry\
                             +   ((struct db_header*)entries)->var_size\
                             )\
                         *   (((struct db_header*)entries)->len + (a) - 1)\
                 )   )   )
#define VAR_STR (&(entry->var[db->header.LList]))
#define MAGIK_00 0x0062446d
#define MAGIK_01 0x0162446d
#define MAGIK_VV MAGIK_01

struct db_header_00
{   unsigned magic;
    unsigned len;
    unsigned N_start;
    unsigned var_size;
    unsigned flags;
#       define PATH_IS_PIPE     1
#       define MAKE_ON_WAKEUP   2
    unsigned char NLists, LList;
    char path[DB_PATH_SIZE];
};
struct db_header
{   unsigned magic;
    unsigned len;
    unsigned N_start;
    unsigned var_size;
    unsigned flags;
#       define PATH_IS_PIPE     1
#       define MAKE_ON_WAKEUP   2
    unsigned char NLists, LList;
    char path[DB_PATH_SIZE];
};
struct db_entry_00
{   unsigned long long subj_hash, mail_hash, repl_hash, id_hash;
    unsigned      offset  /* this message's offset in mailbox            */
    ,            headerl  /* this message's header length                */
    ,              bodyl  /* this message's full length                  */
    ;
    time_t     mail_time; /* time from 'Data: ' line                     */
    time_t   stored_time; /* time entry created                          */
    unsigned        plex  /* entry for previous sorted by subject entry  */
    ,               lext  /* entry for next sorted by subject entry      */
    ;
    short           prev  /* entry offset for previous same level entry  */
    ,               next  /* entry offset for next same level entry      */
    ;
    char           right; /* nest level offset in prev/next chain        */
    unsigned char     th  /* node type in thread                         */
    ,            charset  /* charset in Content-Type: text               */
    ,      encapsulation  /* Content-Transfer-Encoding            */
    ,var[DB_VAR_MAX_SIZE];/* bit mask of lists this entry belongs */
                          /* sender's address                     */
                          /* sender's name                        */
                          /* subject                              */
};
struct db_entry
{   unsigned long long subj_hash, mail_hash, repl_hash, id_hash;
    unsigned      offset  /* this message's offset in mailbox            */
    ,            headerl  /* this message's header length                */
    ,              bodyl  /* this message's full length                  */
    ,              bound  /**/
    ;
    time_t     mail_time; /* time from 'Data: ' line                     */
    time_t   stored_time; /* time entry created                          */
    unsigned        plex  /* entry for previous sorted by subject entry  */
    ,               lext  /* entry for next sorted by subject entry      */
    ;
    short           prev  /* entry offset for previous same level entry  */
    ,               next  /* entry offset for next same level entry      */
    ;
    unsigned char boundl; /**/
    char           right; /* nest level offset in prev/next chain        */
    unsigned char     th  /* node type in thread                         */
    ,            charset  /* charset in Content-Type: text               */
#        define CODEMASK 0200  /* Content-Type: text/html                */
    ,      encapsulation  /* Content-Transfer-Encoding            */
    ,var[DB_VAR_MAX_SIZE];/* bit mask of lists this entry belongs */
                          /* sender's address                     */
                          /* sender's name                        */
                          /* subject                              */
};
struct db
{   struct db_header header;
    struct db_entry entry;
};
struct shformat
{   unsigned char *L_str;
    unsigned char *R_str;
    unsigned char *T_str;
    unsigned char *B_str;
    unsigned char *E_str;
    unsigned char *A_str;
};
struct tinterval
{   time_t tmin;
    time_t tmax;
    int nomin;
    int nomax;
};
enum th_state {th_root, th_cousen, th_brother, th_child, th_hidden, th_purge} th_state;
enum code
{no_code
, code_k
, code_a
, code_w
, code_i
  /* place for new charsets */
, code_unknown=127
} code;
enum encapsulation {none_enc, bit7, bit8, binary, quoted, base64, uu};
enum quost {q_start, q_eq, q_1, q_xxx};
enum qpro {qp_skip, qp_thru, qp_stor, qp_hex, qp_sp, qp_err, qp_ers};
void exr(regex_t *preg, const char *pattern, int cflags);
void perr(int eval, const char *fmt);
